<?
/*--------------------------------------------------------------------
   KorWeblog :: Highly Customizable Weblog/CMS
   Copyright (C) 2001-2004 by Im Eunjea <eunjea@kldp.org>
   For detail of license and/or other info, see the file doc/COPYING.
   http://weblog.kldp.org
----------------------------------------------------------------------

LICENSE

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
----------------------------------------------------------------------*/

include("../include/common.inc.php");
include("auth.inc.php");

$head = _AUTO_STORY;
$out = new KWL_Html;
settype($act, "string");
if ($act == "view") {
	$A = SqlQueryFetchArray("SELECT * FROM T_Auto_Story WHERE Rid = '$rid'");

	if (is_array($A)) {
		include("../include/header.inc.php");
		$topic_info = $TOPIC[$A["Topic"]];
		$topic	= "<a href=\"$CONF[G_URL]/stories.php?topic=$A[Topic]\">$topic_info[Topic]</a>";
		if ($topic_info[ImgURL]) {
			$icon  = "<a href=\"$CONF[G_URL]/?topic=$A[Topic]\">";
			$icon .= "<img src=\"$topic_info[ImgURL]\" alt=\"$topic_info[AltTag]\" align=\"right\" border=\"0\" vspace=\"2\" hspace=\"2\" /></a>";
		}

		$heading	= $A['Heading'];
		$author	= KWL_Author($A);
		$date		= date("Y-m-d h:i a", $A['Poststamp']);
		$link		= KWL_GetIndex($A["Rid"]);
		$content	= KWL_ParseContent($A['Content'],$A['ParseLevel']);

		if ($A[bofile]) {
			$content .= "<p />\n<li>". _ATTCHED_FILE .": ";
			$content .= "<a href=\"$CONF[G_URL]/upload/$A[Topic]/$A[bcfile]/$A[bofile]\">";
			$content .= KWL_icon_check($A['bofile']);
			$content .= " $A[bofile]</a> (" . KWL_FileHSize($A['bfsize'],1) . ")\n";
			$content .= KWL_file_view($A[Topic],$A[bcfile],$A[bofile]);
		}
		$content .= "<div align=\"right\"><a onclick=\"return getconfirm();\" href=\"autostory.php?act=eauto&amp;delarticle=1&amp;rid=$A[Rid]\"><img src=\"$CONF[img_url]/kill.gif\" alt=\"kill\" border=\"0\" /></a>&nbsp;&nbsp;<a href=\"autostory.php?act=edit&amp;rid=$A[Rid]\"><img src=\"$CONF[img_url]/edit.gif\" alt=\"edit\" border=\"0\" /></a></div>";
		
		if ($CONF['SHOW_IP']) $address = "($A[Host])";
		$templatefile	= "$CONF[G_PATH]/backend/template/" . $LAYOUT["TMPL_Story"] . "/story.tmpl";
		$imagedir	= "$CONF[G_URL]/backend/template/" . $LAYOUT["TMPL_Story"] . "/images";
		$template	= addslashes(KWL_ReadFile($templatefile));
		eval("\$tmp=\"". $template ."\";");
		print $tmp;
	} else {
		$msg = urlencode(_NOSTORY);
		KWL_Redirect("admin/autostory.php?msg=$msg");
	}
} elseif ($act == "edit") {
	include("../include/header.inc.php");
	$A = SqlQueryFetchArray("SELECT * FROM T_Auto_Story WHERE Rid = '$rid'");
	if (is_array($A)) {

	$VAR['Content'] = $out->form_start("admin/autostory.php","Edit",$CONF['FILE_UPLOAD']) . $out->table_start("100%",'',0,0,3) ."
<tr>
	<td>* ". _AUTHOR . ":</td>
	<td>". $out->input_form("TEXT","Author",$A['Author'],$size['name'],32) ."</td>
</tr>
<tr>
	<td>* " . _EMAIL . ":</td>
	<td>". $out->input_form("TEXT","AuthorEmail",$A['AuthorEmail'],$size['name'],96) ."</td>
</tr>
<tr>
	<td>" . _URL . ":</td>
	<td>
	". $out->input_form("TEXT","AuthorURL",$A['AuthorURL'],$size['name'],96) ."</td>
</tr>
<tr>
	<td>* " . _TITLE . ":</td>
	<td>". $out->input_form("TEXT","Heading",$A['Heading'],$size['titl'],96) ."</td>
</tr>
<tr>
	<td>". _TOPIC . ":</td>
	<td>". $out->topicsel($A["Topic"],"post") ."
</tr>
<tr>
	<td colspan=\"2\">". _SUMMARY . ":
	<br />". $out->textarea("Summary",5,$size['text'],KWL_PrepareHtml($A['Summary'])) ."</td>
</tr>
<tr>
	<td colspan=\"2\">* ". _STORY .": ". KWL_FormResizer("Edit.Content",$size['text'],10) ."
	<br />". $out->textarea("Content",10,$size['text'],KWL_PrepareHtml($A['Content'])) ."</td>
</tr>
<tr>
   <td colspan=\"2\">". KWL_MakeSelectParse($CONF['story_parse'],$A['ParseLevel']) ."
</td>
</tr>\n";

if ($CONF['EmailComments']) {
	$VAR['Content'] .= "<tr>
	<td colspan=\"2\">". $out->check_box("EmailComments",$A['EmailComments']) ." ". _MAILCOMMENTS . "</td>
</tr>";
}

if (SqlCount("T_IndexNames")) {
	$VAR['Content']   .= "<tr><td colspan=\"2\"><br /><H3>" . _RELATED . ":</H3></td></tr>";
	$VAR['Content']	.= KWL_EditIndex($A["Rid"]);
}

if ($A['bofile']) {
	$VAR['Content'] .= "
<tr>
	<td>". _ATTCHED_FILE .":</td>
	<td>
	<a href=\"$CONF[G_URL]/upload/$A[Topic]/$A[bcfile]/$A[bofile]\">"
	. KWL_icon_check($A['bofile']) . " " . $A[bofile] ."</a> (" . KWL_FileHSize($A[bfsize]) . ") ";
	$VAR['Content'] .= $out->check_box("deletefile") ." ". _DELETE_FILE 
	." ". $out->input_form("HIDDEN","origfile",$A['bofile']);

} else if ($CONF['FILE_UPLOAD']) {
	$VAR['Content'] .= "
<tr>
   <td>"._FILE.":</td>
   <td>"
	. $out->input_form("HIDDEN","addfile",1)
	. $out->input_form("HIDDEN","max_file_size",$CONF['FILE_MAX_SIZE'])
	. $out->input_form("file","userfile",'',KWL_FormSize(15),256) ."<br />
   <br />
</td></tr>";
}

$year		= date("Y", $A['Poststamp']);
$day		= date("d", $A['Poststamp']);
$month	= date("m", $A['Poststamp']);
$hour		= date("H", $A['Poststamp']);
$min		= date("i", $A['Poststamp']);

$VAR['Content'] .= "
<tr>
	<td colspan=\"2\">". _CURRENT_TIME .": ". date("Y-m-d H:i", time()) ."<br />
	<b>". _POSTING_TIME ."</b>:<br />
	". KWL_MakeTimeSelect($year,$day,$month,$hour,$min) ."</td>
</tr>
";

$VAR['Content'] .= "
<tr>
	<td colspan=\"2\">"
	. $out->input_form("HIDDEN","oldtopic",$A['Topic'])
	. $out->input_form("HIDDEN","oldfile",$A['bcfile'])
	. $out->input_form("HIDDEN","rid",$A['Rid'])
	. $out->input_form("HIDDEN","act","eauto")
	. $out->input_form("SUBMIT","mode",_EDIT) ."</td>
</tr>". $out->table_end() . $out->form_end();

$VAR['Heading'] = _EDIT;
KWL_DrawMain($VAR);
	}

} elseif ($act == "eauto") {

	if ($delarticle) {
		$sql = "DELETE FROM T_Auto_Story";
		$deletefile = 1;
	} else {

	if (empty($Summary)) $summ = KWL_genSummary($Content);
	else $summ = KWL_genSummary($Summary);
	$Content = chop(ltrim($Content));
	$summ = chop(ltrim($summ));
   list($Heading,$Author) = KWL_PrepareHtml($Heading,$Author);
	$program_time = mktime($hour,$min,0,$month,$day,$year);

	$AuthorEmail = KWL_EmailCheck($AuthorEmail);

	$tmp = $EmailComments=="on" ? "1" : "0";
	$sql	= "UPDATE T_Auto_Story SET Topic=$Topic , Heading='$Heading' , Summary='$summ' , Content='$Content', Author='$Author', AuthorEmail='$AuthorEmail', AuthorURL='$AuthorURL', EmailComments = $tmp, Poststamp = $program_time, ParseLevel = $ParseLevel";

	if (!empty($_FILES['userfile']['name'])) {
		$updir = date("YmdHis",time());
		$file = KWL_FileUpload($_FILES['userfile'],"$CONF[G_PATH]/upload/$Topic",$updir,$CONF['FILE_MAX_SIZE']);
		if (!is_array($file)) KWL_ShowError(_UPLOAD_FAILED);
		$sql .= ", bofile = '$file[name]', bcfile = '$updir', bfsize = '$file[size]'";
	} else if ($deletefile) $sql .= ", bofile = '', bcfile = '', bfsize = ''";
	
	}
	$sql .= " WHERE Rid = '$rid'";

	if (SqlQuery($sql)) {
		if ($deletefile) {
			@unlink("$CONF[G_PATH]/upload/$oldtopic/$oldfile/$origfile");
         @unlink("$CONF[G_PATH]/upload/$oldtopic/$oldfile/$origfile"."_t.jpg");
			@rmdir("$CONF[G_PATH]/upload/$oldtopic/$oldfile");
		}
		KWL_StoryLink($Links,$rid);

		#  ִ  ش  ű
		if ($oldfile && $Topic != $oldtopic) {
			if (!file_exists("$CONF[G_PATH]/upload/$Topic")) mkdir("$CONF[G_PATH]/upload/$Topic",0755);
			exec("$exec[mv] \"$CONF[G_PATH]/upload/$oldtopic/$oldfile\" \"$CONF[G_PATH]/upload/$Topic/\"");
		}
		if ($delarticle) $msg = urlencode(_STORY_PROGRAM_DELETED);
		else $msg = urlencode(_STORY_PROGRAM_EDITED);
		KWL_Redirect("admin/autostory.php?msg=$msg");
		exit;
	} else KWL_ShowError(SQL_ERROR);

} else {

include("../include/header.inc.php");

$VAR['Heading'] = _AUTO_STORY;
$VAR['Content'] = $out->form_start("admin/submit.php","config")
. $out->table_start("100%") ."
<tr>
	<td ALIGN=CENTER>". $out->radio("Auto_Posting",array(_NOTUSE,_USE),$CONF['Auto_Posting'])
	. $out->input_form("HIDDEN","what","autostory")
	. $out->input_form("SUBMIT","mode",_SAVE_CHANGE) ."</td>
</tr>". $out->table_end() . $out->form_end();
KWL_DrawMain($VAR);

$sql	= "SELECT * FROM T_Auto_Story ORDER BY Poststamp ASC";
$result	= SqlQuery($sql);
$VAR['Heading'] = _STORY_WATING;
if (mysql_num_rows($result)) {

	$VAR['Content'] = $out->table_start("100%",'',1,0,3)
	. "<tr><td>". _TOPIC ."</td>"
	. "<td>". _TITLE ."</td>"
	. "<td>". _POSTING_TIME ."</td>"
	. "<td>&nbsp;</td></tr>";
	
	while ($A = mysql_fetch_array($result)) {
		$topic_info = $TOPIC[$A['Topic']];
		$VAR['Content'] .= "<tr><td>$topic_info[AltTag]</td>"
		. "<td><A HREF=\"autostory.php?act=view&rid=$A[Rid]\">$A[Heading]</A></td>"
		. "<td>" . date("Y-m-d h:i a", $A['Poststamp']) ."</td>"
		. "<td><a onclick=\"return getconfirm();\" href=\"autostory.php?act=eauto&amp;delarticle=1&amp;rid=$A[Rid]\"><img src=\"$CONF[img_url]/kill.gif\" alt=\"kill\" border=\"0\" /></a>&nbsp;&nbsp;<a href=\"autostory.php?act=edit&amp;rid=$A[Rid]\"><img src=\"$CONF[img_url]/edit.gif\" ALT=\"edit\" border=\"0\" /></a></td></tr>";
	}
	$VAR['Content'] .= $out->table_end();
	KWL_DrawMain($VAR);
} else {
	$VAR['Content'] = "<br />" . _NO_PROGRAM_STORY . "<br /><br />";
	KWL_DrawMain($VAR);
}

}
include("../include/footer.inc.php");
?>
