<?
/*--------------------------------------------------------------------
   KorWeblog :: Highly Customizable Weblog/CMS
   Copyright (C) 2001-2004 by Im Eunjea <eunjea@kldp.org>
   For detail of license and/or other info, see the file doc/COPYING.
   http://weblog.kldp.org
----------------------------------------------------------------------

LICENSE

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
----------------------------------------------------------------------*/

include("../include/common.inc.php");
include("auth.inc.php");
include("../include/header.inc.php");

function KWL_ViewLog($type) {
	$CONF = KWL_GetConf();

	$filename = $CONF['G_PATH'] . "/logs/" . $type . ".log";
	$contents = KWL_ReadFile($filename);

	$VAR["Heading"]	=  KWL_PrepareHtml($CONF['SiteName']) . " " . ucfirst($type) . " Log";
	if (!empty($contents)) {
		$VAR["Content"]	= nl2br($contents);
	} else {
		$VAR["Content"] = _LOGS_NOTHING . ".<br>\n";
	}
	$VAR["Content"]	.= KWL_ResetButton($type);
	KWL_DrawMain($VAR);
}

function KWL_ResetButton($type) {
	$s	= "<form action=\"". $_SERVER['PHP_SELF'] ."\" method=POST>\n";
	$s	.= "<input type=hidden name=\"what\" value=\"$type\">\n";
	$s	.= "<input type=submit value=\"" . ucfirst($type) . " Log "._LOGS_RESET."\">\n";
	$s	.= "</form>\n";
	return $s;
}

if (!empty($what)) {
	if ($what=="moderator"){
		SqlQuery("DELETE FROM moderatorlog");
	} else {
		$fp=fopen($CONF['G_PATH'] . "/logs/" . $what . ".log", 'wb');
		fclose($fp);
		if ($what=="access") {
			KWL_AccessLog(_LOG_RESET);
		}
	}
}

KWL_ViewLog("access");
KWL_ViewLog("error");

$VAR['Content'] = "";
$sql  = "SELECT * FROM T_Users WHERE user_level = 1 ORDER BY uid ASC";
$moder = SqlReturnArray($sql);

if (count($moder)) {
	foreach ($moder as $A) {
		$sql = "SELECT * FROM moderatorlog WHERE mid='$A[uid]' ORDER BY time ASC";
		$log_result = SqlQuery($sql);
		if (mysql_num_rows($log_result)) {
			$VAR['Content'] .= "<HR><B>Moderator: $A[name]</B><BR>";
			while ($LOG = mysql_fetch_array($log_result)) {
				$VAR['Content'] .= "<LI>" . $LOG['act'] . "</LI>";
			}
		} else $VAR['Content'] = _LOGS_NOTHING . ".<br>\n";
	}
}
$VAR['Content'] .= KWL_ResetButton("moderator");
$VAR['Heading'] = "Moderator Log";
KWL_DrawMain($VAR);

include("../include/footer.inc.php");
?>
