<?
/*--------------------------------------------------------------------
   KorWeblog :: Highly Customizable Weblog/CMS
   Copyright (C) 2001-2004 by Im Eunjea <eunjea@kldp.org>
   For detail of license and/or other info, see the file doc/COPYING.
   http://weblog.kldp.org
----------------------------------------------------------------------

LICENSE

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
----------------------------------------------------------------------*/

include("../include/common.inc.php");
include("auth.inc.php");
include("../include/header.inc.php");

$rbutton_table = "T_Random_Buttons";
$button_path = "buttons";

if (empty($CONF['rbutton_title'])) $CONF['rbutton_title'] = _RANDOM_BUTTON;
settype($act, "string");
if ($act == "add") {
   $url = KWL_UrlCheck($url);
   if ($url && $img_url) {
      SqlQuery("INSERT INTO $rbutton_table (url,img_url,alt) VALUES ('$url','$img_url','$alt')");
   }

} elseif ($act == "editok" && $id) {
   $url = KWL_UrlCheck($url);
   $alt = trim($alt);
   if ($url && $img_url) {
      SqlQuery("UPDATE $rbutton_table SET url = '$url', img_url = '$img_url', alt = '$alt' WHERE id = $id");
   }

} elseif ($act == "nums" && $rbutton_nums) {
   if (SqlCount("T_Config","Name","rbutton_nums")) {
      SqlQuery("UPDATE T_Config SET Value = $rbutton_nums WHERE Name = 'rbutton_nums'");
   } else {
      SqlQuery("INSERT INTO T_Config (Name,Value) VALUES ('rbutton_nums','$rbutton_nums')");
   }
   $rbutton_title = KWL_PrepareHtml($rbutton_title);
   if (SqlCount("T_Config","Name","rbutton_title")) {
      SqlQuery("UPDATE T_Config SET Value = '$rbutton_title' WHERE Name = 'rbutton_title'");
   } else {
      SqlQuery("INSERT INTO T_Config (Name,Value) VALUES ('rbutton_title','$rbutton_title')");
   }
   $CONF['rbutton_nums'] = $rbutton_nums;
   $CONF['rbutton_title'] = $rbutton_title;
} elseif ($act == "kill" && $id) {
   SqlQuery("DELETE FROM $rbutton_table WHERE id = $id");   
} elseif ($act == "scan") {
   $buttons = KWL_GetFileName("$CONF[G_PATH]/$button_path");
   if (is_array($buttons)) {
      foreach ($buttons as $img) {
         $img_url = "$button_path/$img";
         if (!SqlCount($rbutton_table,"img_url",$img_url)) {
            SqlQuery("INSERT INTO $rbutton_table (img_url) VALUES ('$img_url')");
         }
      }
   }
}

$out = new KWL_Html;
$VAR['Content'] = $out->form_start("admin/random_button.php","rbutton").
                $out->table_start("100%",'',0,0,5).
                "<tr><td>$button_path/*.* :</td><td>".
                "<a href=\"". $_SERVER['PHP_SELF'] ."?act=scan\">Scan</a></td></tr>".
                "<tr><td>". _RANDOM_BUTTON_NUMS .":</td><td>".
                $out->input_form("text","rbutton_nums",$CONF['rbutton_nums'],KWL_FormSize(2),5).
                "</td></tr>".
                "<tr><td>". _RANDOM_BUTTON_HEAD .":</td><td>".
                $out->input_form("text","rbutton_title",$CONF['rbutton_title'],KWL_FormSize(15),255).
                "</td></tr><tr><td colspan=2>".                
                $out->input_form("hidden","act","nums").
                $out->input_form("submit",'',_SAVE_CHANGE).
                "</td></tr>". $out->table_end() . $out->form_end();
                
$VAR['Heading'] = _RANDOM_BUTTON;
KWL_DrawMain($VAR);

if ($act == "edit") {
   $rt = SqlQueryFetchArray("select * from $rbutton_table where id = $id");
   $VAR['Content'] = rbutton_form($out,$rt);
   $VAR['Heading'] = "<a name=\"button_edit\">". _RANDOM_BUTTON_EDIT ."</a>";
} else {
   $VAR['Content'] = rbutton_form($out);
   $VAR['Heading'] = _RANDOM_BUTTON_ADD;
}
KWL_DrawMain($VAR);

settype($by, "string");
if ($by=="id" || $by=="url" || $by=="alt" || $by=="hits") {
   if ($sort=="asc") { $sort = "$by $sort"; $rsort = "desc"; }
   else if ($sort=="desc") { $sort = "$by $sort"; $rsort = "asc"; }
   else { $sort = "id asc"; $rsort = "desc"; }
} else { $sort = "id asc"; $rsort = "desc"; }


$rt = SqlQuery("SELECT * FROM $rbutton_table ORDER BY $sort");

if (mysql_num_rows($rt)) {
   $VAR['Content'] = $out->table_start("100%",'',1,0,5).
                   "<tr><th><a href=\"". $_SERVER['PHP_SELF'] ."?by=id&sort=$rsort\">no</a></th>".
                   "<th>img</th>".
                   "<th><a href=\"". $_SERVER['PHP_SELF'] ."?by=url&sort=$rsort\">url</a></th>".
                   "<th><a href=\"". $_SERVER['PHP_SELF'] ."?by=alt&sort=$rsort\">". _RANDOM_BUTTON_ALT ."</a></th>".
                   "<th><a href=\"". $_SERVER['PHP_SELF'] ."?by=hits&sort=$rsort\">hits</a></th>".
                   "<th>op</th>";
   $no = 1;
   while ($A = mysql_fetch_array($rt)) {
      if (!preg_match('!^http!', $A['img_url'])) $A['img_url'] = "$CONF[G_URL]/$A[img_url]";
      $VAR['Content'] .= "<tr><td>$no</td>".
                       "<td><img src=\"$A[img_url]\" BORDER=\"0\" VSPACE=\"1\" HSPACE=\"1\" ALT=\"". KWL_PrepareHtml($A['alt']) ."\"></td>".
                       "<td><a href=\"$A[url]\" target=\"_blank\">$A[url]</a></td>".
                       "<td>". KWL_PrepareHtml($A['alt']) ."</td>".
                       "<td>". number_format($A['hits']) ."</td>".
                       "<td><A ONCLICK=\"return getconfirm();\" HREF=\"". $_SERVER['PHP_SELF'] ."?act=kill&id=$A[id]\"><IMG SRC=\"$CONF[img_url]/kill.gif\" ALT=\"kill\" BORDER=\"0\"></A>&nbsp;<A HREF=\"". $_SERVER['PHP_SELF'] ."?act=edit&id=$A[id]#button_edit\"><IMG SRC=\"$CONF[img_url]/edit.gif\" ALT=\"edit\" BORDER=\"0\"></A></td></tr>";
      $no++;
   }
   $VAR['Content'] .= $out->table_end();
   $VAR['Heading'] = _RANDOM_BUTTON;
   KWL_DrawMain($VAR);
}
include("../include/footer.inc.php");

function rbutton_form($out,$A='') {
   if (is_array($A)) {
      $what = "editok";
      if (!preg_match('!^http!', $A['img_url']))
         $A['img_url'] = KWL_GetConf('G_URL') ."/". $A['img_url'];
   } else {
      $what = "add";
      $A['url'] = $A['id'] = $A['img_url'] = $A['alt'] = "";
   }
   
   return $out->form_start("admin/random_button.php","rbutton").
          $out->table_start("100%",0,0,5).
          "<tr>".
          "<td>* Url:</td>".
          "<td>". $out->input_form("text","url",$A['url'],KWL_FormSize(20),255) ."</td></tr>".
          "<td>* Image Url:</td>".
          "<td>". ($A['img_url'] ? "<img src=\"$A[img_url]\" BORDER=\"0\" VSPACE=\"1\" HSPACE=\"1\"><BR>" : "") .
          $out->input_form("text","img_url",$A['img_url'],KWL_FormSize(20),255) ."</td></tr>".
          "<tr><td>". _RANDOM_BUTTON_ALT .":</td>".
          "<td>". $out->input_form("text","alt",KWL_PrepareHtml($A['alt']),KWL_FormSize(20),255) ."</td></tr>".
          "<tr><td colspan=2>".
          $out->input_form("hidden","id",$A['id']).
          $out->input_form("hidden","act",$what).
          $out->input_form("submit",'',_SAVE_CHANGE).
          "</td></tr>". $out->table_end() . $out->form_end();
}
?>
