<?
/*--------------------------------------------------------------------
   KorWeblog :: Highly Customizable Weblog/CMS
   Copyright (C) 2001-2004 by Im Eunjea <eunjea@kldp.org>
   For detail of license and/or other info, see the file doc/COPYING.
   http://weblog.kldp.org
----------------------------------------------------------------------

LICENSE

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
----------------------------------------------------------------------*/

include("include/common.inc.php");

if ($CONF['AllowContrib']==0 && !KWL_CheckAdmin()) {
	$msg	= urlencode(_NOPOSTING);
	KWL_Redirect("stories.php?msg=$msg");
}

$out = new KWL_Html;
$VAR['Content'] = $out->form_start("preview.php","Contrib",$CONF['FILE_UPLOAD']) .
       $out->table_start("100%",'',0,0,3);

if ($add_file = KWL_ReadFile("logs/contrib_add.txt")) {
   $VAR['Content'] .= "<tr><td colspan=\"2\">$add_file</tr></td>\n";
}

$VAR['Content'] .= "<tr><td width=\"20%\">* <b>" . _NAME . "</b></td>\n";

if ($login && is_array($user)) {
   $VAR['Content'] .= "<td><a href=\"$G_URL/profiles.php?uid=$user[uid]\">".
           KWL_PrepareHtml($user['name']) ."</a>".
           $out->input_form("hidden","Author",$user['name']).
           $out->input_form("hidden","AuthorEmail",$user['email']).
           $out->input_form("hidden","AuthorURL",$user['url']).
           "</td></tr>\n";
} else {
   $u = KWL_GetCookieUser();
   $VAR['Content'] .= "
	<td>". $out->input_form("text","Author",$u[0],$size['name'],32) ."</td>
</tr>
<tr>
	<td>* <b>". _EMAIL ."</b></td>
	<td>". $out->input_form("text","AuthorEmail",$u[1],$size['name'],96) ."</td>
</tr>
<tr>
	<td>". _URL ."</td>
	<td>". $out->input_form("text","AuthorURL",$u[2],$size['name'],96) ."</td>
</tr>";
   }

settype($topic, "integer");
$VAR['Content'] .= "
<tr>
	<td>* <b>" . _TITLE . "</b></td>
	<td>". $out->input_form("text","Heading",'',$size['titl'],96) ."</td>
</tr>
<tr>
	<td>* <b>". _TOPIC . "</b></td>
	<td>". $out->topicsel($topic,"post") ."</td>
</tr>";

if ($CONF['SummaryLength']) {
   $VAR['Content'] .= "
<tr>
	<td colspan=\"2\">". _SUMMARY . ": (" . _OPTIONAL . ")<br />
	". $out->textarea("Summary",5,$size['text']) ."
	</td>
</tr>";
}

$VAR['Content'] .= "
<tr>
	<td colspan=\"2\">* <b>". _STORY . "</b>: ". KWL_FormResizer("Contrib.Content",$size['text'],10) ."
<br />". $out->textarea("Content",10,$size['text']) ."
	</td>
</tr>
<tr>
	<td colspan=\"2\">". KWL_MakeSelectParse($CONF['story_parse'],$CONF['ParseLevel']) ."
	</td>
</tr>
";

if (SqlCount("T_IndexNames")) $VAR['Content'] .= KWL_EditIndex();

if ($CONF['EmailComments']) {
$VAR['Content'] .= "
<tr>
	<td colspan=\"2\">". $out->check_box("EmailComments",1) ." ". _MAILCOMMENTS . "</td>
</tr>";
}

if ($CONF['FILE_UPLOAD']) {
$VAR['Content'] .= "
<tr>
	<td>"._FILE."</td>
	<td>"
	. $out->input_form("HIDDEN","max_file_size",$CONF['FILE_MAX_SIZE'])
	. $out->input_form("file","userfile",'',KWL_FormSize(20),256) ."<br />
</td></tr>";
}

if ($CONF['ENABLE_EDIT'] && !$login) {
$VAR['Content'] .= "
<tr>
	<td>"._PASSWD."</td>
	<td>"
	. $out->input_form("password","passwd",'',KWL_FormSize(10),10) ."<br />
	* ". _PASS_DESC ."
</td></tr>";
}

if ($CONF['admin_login']) {
$VAR['Content'] .= "
<tr>
	<td colspan=\"2\"><b>"._STORY_PROGRAM."</b>
	". $out->select("autostory",array(_NOTUSE,_USE)) ."
	<br /><b>". _CURRENT_TIME ."</b> ". date("Y-m-d H:i", time()) ."</td>
</tr>
<tr>
	<td colspan=\"2\">". KWL_MakeTimeSelect() ."</td>
</tr>
";
}

$VAR['Content'] .= "
<tr>
	<td colspan=\"2\">"
	. $out->input_form("hidden","hcode",KWL_HcodeMake(KWL_GetConf("SiteKey")))
   . ($CONF['story_parse'] ? "" : $out->input_form("submit","mode",_SUBMIT))
	. $out->input_form("submit","mode",_PREVIEW) 
   . ($CONF['story_parse'] ? _MUST_PREVIEW : "") ."</td>
</tr>". $out->table_end() . $out->form_end();

$head = _CONTRIB;
include("include/header.inc.php");
$VAR['Heading'] = _CONTRIBUTE;
KWL_DrawMain($VAR);
include("include/footer.inc.php");
?>
