<?
/*--------------------------------------------------------------------
   KorWeblog :: Highly Customizable Weblog/CMS
   Copyright (C) 2001-2004 by Im Eunjea <eunjea@kldp.org>
   For detail of license and/or other info, see the file doc/COPYING.
   http://weblog.kldp.org
----------------------------------------------------------------------

LICENSE

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
----------------------------------------------------------------------*/

if (!defined("LOAD_MODULE"))
   die ("You can not access this file directly...");
include("$CONF[G_PATH]/include/kmod/session/lang/$CONF[Language]". ".php");

@session_start();
$sessid = session_id();

$domain = $_SERVER['HTTP_HOST'];
if (empty($domain)) $domain = $CONF['G_URL'];
$domain = preg_replace('/:.*/', '', $domain);
ini_set('session.cookie_domain', $domain);
ini_set('session.cookie_lifetime', $CONF['Session_tmout'] * 60);
ini_set('session.gc_maxlifetime', $CONF['Session_tmout'] * 60);
ini_set('session.auto_start', 1);

$ipaddr = KWL_GetIP();
$expire_time = time() - ($CONF['Session_tmout'] * 60);

if ($login) {
	$sql  = "SELECT sessid, ipaddr, lastused, uid FROM T_Session WHERE ";
	$sql .= "uid = '$user[uid]'";
	$A = SqlQueryFetchArray($sql);
	
	if (!empty($A['sessid']) && $A['sessid'] == $sessid) {
		if ($expire_time > $A['lastused']) {
			$sql  = "UPDATE T_Session SET lastused = ". time() ." WHERE ";
			$sql .= "sessid = '$sessid' AND uid = '$user[uid]'";
			SqlQuery($sql);
		}
	} else {
		SqlQuery("DELETE FROM T_Session WHERE uid = '$user[uid]'");
		SqlQuery("REPLACE INTO T_Session VALUES ('$sessid', '$ipaddr', '". time() ."', '$user[uid]')");
      KWL_Make_Stats();
	}
} else {
	$sql  = "SELECT sessid, ipaddr, lastused, uid FROM T_Session WHERE ";
	$sql .= "(sessid = '$sessid' OR ipaddr = '$ipaddr') AND uid = 0";
	$A = SqlQueryFetchArray($sql);

	if (is_array($A)) {
		if ($expire_time > $A['lastused']) {
			$sql  = "UPDATE T_Session SET lastused = ". time() ." WHERE ";
			$sql .= "sessid = '$A[sessid]' AND uid = 0";
			SqlQuery($sql);
		}
	} else {
		SqlQuery("REPLACE INTO T_Session VALUES ('$sessid', '$ipaddr', '". time() ."', 0)");
      KWL_Make_Stats();
	}
}
/* delete all entry if lastused < expire_time */
SqlQuery("DELETE FROM T_Session WHERE lastused < $expire_time");
@session_destroy();

function KWL_SessionGetOnline() {
	global $expire_time;
	$sql  = "SELECT COUNT(1/(uid = 0)), COUNT(1/(uid > 0)) ";
	$sql .= "FROM T_Session WHERE lastused > $expire_time";
	return SqlQueryFetchArray($sql);
}

function KWL_SessionGetInfo($uid) {
	return SqlQueryFetchArray("SELECT sessid, ipaddr, lastused, uid FROM T_Session WHERE uid = '$uid'");
}

function KWL_Make_Stats() {
   $CONF = KWL_GetConf();
   
   if ($CONF['Counter']) {
      include_once($CONF['G_PATH'] ."/include/kmod/counter/index.php");
      KWL_counter();
   }
   if ($CONF['Referer']) {
      include_once($CONF['G_PATH'] ."/include/kmod/referer/index.php");
      KWL_referer();
   }
   if ($CONF['Time_Counter']) {
      include_once($CONF['G_PATH'] ."/include/kmod/counter/index.php");
      KWL_update_time_counter();
   }
}
?>
