<?
/*--------------------------------------------------------------------
   KorWeblog :: Highly Customizable Weblog/CMS
   Copyright (C) 2001-2004 by Im Eunjea <eunjea@kldp.org>
   For detail of license and/or other info, see the file doc/COPYING.
   http://weblog.kldp.org
----------------------------------------------------------------------

LICENSE

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
----------------------------------------------------------------------*/

function KWL_DrawStory($A,$whe='',$preview=0) {
   global	$LAYOUT,$user,$TOPIC,$login,$user,$trackback;
   $CONF = KWL_GetConf();
	
   $topic_info =& $TOPIC[$A["Topic"]];
   $topic = "<a title=\"$topic_info[Topic]\" href=\"$CONF[G_URL]/stories.php?topic=$A[Topic]\">$topic_info[Topic]</a>";
   if ($topic_info['ImgURL'] && empty($user['config']['iconoff'])) {
      $icon  = "<a href=\"$CONF[G_URL]/?topic=$A[Topic]\">";
      $icon .= "<img src=\"$topic_info[ImgURL]\" alt=\"$topic_info[AltTag]\" align=\"right\" border=\"0\" vspace=\"2\" hspace=\"2\" /></a>";
   } else $icon = "";

   $heading	= $A['Heading'];
   if ($preview) $heading = KWL_PrepareHtml($heading);
   $author = KWL_Author($A);
   $date		= KWL_DateFormat($A["Birthstamp"]);
   $link		= KWL_GetIndex($A["Rid"]);
   $content	= "<span class=\"story\">\n". KWL_ParseContent($A["Content"],$A["ParseLevel"]) ."\n</span>\n";

   if ($A['bofile']) {
      $content .= "<p /><b>\n". _ATTCHED_FILE ."</b>: ";
      $content .= "<a title=\"". _ATTCHED_FILE ."\" href=\"$CONF[G_URL]/upload/$A[Topic]/$A[bcfile]/$A[bofile]\" target=\"_blank\">";
      $content .= KWL_icon_check($A['bofile']);
      $content .= " $A[bofile]</a> (" . KWL_FileHSize($A['bfsize'],1) . ")\n";
      if (file_exists("$CONF[G_PATH]/upload/$A[Topic]/$A[bcfile]/$A[bofile]"))
         $content .= KWL_file_view($A['Topic'],$A['bcfile'],$A['bofile']);
      else $content .= "<p />File is not exist!";
   }

   if (!$preview) {
      if ($A["Repostamp"]>$A["Birthstamp"]) $content	.= "<br /><b>" . _REPOSTED . " " . KWL_DateFormat($A["Repostamp"]) . "</b>";
      if ($CONF['admin_login']) $content	.= "<br />\n" . KWL_AdminLinki("T_Stories",$A["Rid"],$whe);
      
      $add = "";

      if ($CONF['ENABLE_EDIT'] && !$CONF['admin_login']) {
         settype($user['name'],"string");
         if ($CONF['NoLogin_User'] || $A['Author'] == $user['name']) {
            $add = "<span class=\"story-edit\">[<a title=\"". _EDIT ."\" href=\"edit.php?mode=story&amp;story=$A[Rid]\">". _EDIT ."</a>]</span>";
         }
      }
      
      if ($CONF['Bookmark'] && $login) $add .= " <span title=\"". _BOOKMARK ."\" class=\"bookmark\">[<a href=\"user.php?what=mark&amp;rid=$A[Rid]\">". _BOOKMARK ."</a>]</span>";
      if (!empty($add)) {
         $content .= "<div align=\"right\"><font size=\"-1\">$add</font></div>";
      }
	}

	if ($CONF['SHOW_IP']) $address = "($A[Host])";

   if ($CONF['trackback']) {
      $trackback = SqlCount("T_Trackback","Rid",$A['Rid']);
      $topic .= "&nbsp;<a title=\"Permalink\" href=\"". KWL_MakeStoryLink($A['Rid']) ."\">#</a>&nbsp;".
         "<a class=\"links\" title=\""._TRACKBACK."\" onclick=\"new_windows('tb.php?story={$A['Rid']}','trackback',1,1,650,460); return false\" href=\"tb.php?story={$A['Rid']}\">". 
         _TRACKBACK ."($trackback)</a> ";
      /* we need this? */
      $topic .= <<<TBRDF

<!--
   <rdf:RDF xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
   xmlns:dc="http://purl.org/dc/elements/1.1/"
   xmlns:trackback="http://madskills.com/public/xml/rss/module/trackback/">
   <rdf:Description
   rdf:about="{$CONF['G_URL']}/stories.php?story={$A['Rid']}"
   trackback:ping="{$CONF['G_URL']}/tb.php/{$A['Rid']}?act=tb"
   dc:title="{$A['Heading']}"
   dc:identifier="{$CONF['G_URL']}/stories.php?story={$A['Rid']}" />
   </rdf:RDF> 
-->

TBRDF;
   }
   
   if ($CONF["PrintStory"]) $topic .= " <a title=\"". _PRINTFRIEND ."\" target=\"_blank\" href=\"$CONF[G_URL]/print.php?story=$A[Rid]\"><img src=\"$CONF[G_URL]/images.d/print.gif\" border=\"0\" width=\"15\" height=\"11\" alt=\"". _PRINTFRIEND ."\" hspace=\"3\" /></a>";
   if ($CONF["MailFriend"]) $topic .= " <a title=\"". _MAILTOFRIEND ."\" href=\"$CONF[G_URL]/friend.php?story=$A[Rid]\"><img src=\"$CONF[G_URL]/images.d/friend.gif\" border=\"0\" width=\"15\" height=\"11\" alt=\"" . _MAILTOFRIEND . "\" hspace=\"3\" /></a>";			
   $imagedir	= "$CONF[G_URL]/backend/template/" . $LAYOUT["TMPL_Story"] . "/images";
   $views      = _VIEWS . " " . number_format($A["Hits"]);
   $template	= addslashes(KWL_ReadFile("$CONF[G_PATH]/backend/template/$LAYOUT[TMPL_Story]/story.tmpl"));
   eval("\$tmp=\"". $template ."\";");
   print $tmp;
}

function KWL_DrawSummary($A,$whe="") {
   global $LAYOUT,$TOPIC,$user;
   static $template;
   $CONF = KWL_GetConf();

   if (!isset($template)) {
      $template  = addslashes(KWL_ReadFile("$CONF[G_PATH]/backend/template/$LAYOUT[TMPL_Summary]/summary.tmpl"));
   }   

   $topic_info = $TOPIC[$A["Topic"]];
   $topic = "<a title=\"$topic_info[Topic]\" href=\"$CONF[G_URL]/stories.php?topic=$A[Topic]\">$topic_info[Topic]</a>";
   if ($topic_info['ImgURL'] && empty($user['config']['iconoff'])) {
      $icon  = "<a href=\"$CONF[G_URL]/?topic=$A[Topic]\">".
               "<img src=\"$topic_info[ImgURL]\" alt=\"$topic_info[AltTag]\" align=\"right\" border=\"0\" vspace=\"2\" hspace=\"2\" /></a>";
   } else $icon = "";

   $heading	= "<a class=\"title\" href=\"". KWL_MakeStoryLink($A['Rid']) .
      ((!empty($_GET['topic'])) ? "&amp;topic={$_GET['topic']}" : '') ."\">$A[Heading]</a>";
   $author	= KWL_Author($A);
   $date		= "<span class=\"date\">". KWL_DateFormat($A["Birthstamp"]) ."</span>";
   $content	= KWL_ParseContent($A["Summary"],$A["ParseLevel"]);
   
   if ($CONF["SummaryLength"]>0 && $A["Summary"] != $A["Content"])
      $content	.= "...";

   $content = "<span class=\"summary\">\n". $content ."\n</span>\n";

   if ($CONF['admin_login']) $content	.= "<br />\n" . KWL_AdminLinki("T_Stories",$A["Rid"],$whe);
   
   if ($A['bofile']) {
      $content .= "<p />\n<span class=\"upload-file\">". _ATTCHED_FILE .": ".
       "<a title=\"". _ATTCHED_FILE ."\" href=\"$CONF[G_URL]/upload/$A[Topic]/$A[bcfile]/$A[bofile]\" target=\"_blank\">".
       KWL_icon_check($A['bofile']).
       " $A[bofile]</a> (" . KWL_FileHSize($A['bfsize']) . ")</span>\n";
   }
	
   if ($A["Repostamp"]>$A["Birthstamp"]) $content	.= "<br /><i>" . _REPOSTED . " " . KWL_DateFormat($A["Repostamp"]) . "</i>";
   
   $link	= KWL_GetIndex($A["Rid"]);
   $address = $CONF['SHOW_IP'] ? "($A[Host])" : "";
   
   $vcmts = $A['replys'] > 1 ? _COMMENTS : _COMMENT;
   if ($A['replys']) {
      $tmp = $CONF['Language'] == "korean" ? _COMMENT . " " . $A['replys'] . _FIX : "(" . $A['replys'] . " " . $vcmts . ")";
   }
   else $tmp = "-- " . _COMMENT;

   $comments = $CONF['Comments'] ? sprintf("<a class=\"links\" href=\"stories.php?story=%s\">" . _READMORE . " %s</a>\n",$A["Rid"],$tmp) : sprintf("<a href=\"stories.php?story=%s\">" . _READMORE . "</a>\n",$A["Rid"]);

   if ($CONF['trackback']) {
      $trackback = SqlCount("T_Trackback","Rid",$A['Rid']);
      $comments .= " <a class=\"links\" title=\""._TRACKBACK."\" onclick=\"new_windows('tb.php?story={$A['Rid']}','trackback',1,1,650,460); return false\" href=\"tb.php?story={$A['Rid']}\">". 
         _TRACKBACK . "($trackback)</a> ";
   }
   
   if ($CONF['PrintStory']) $comments .= " <a target=\"_blank\" href=\"$CONF[G_URL]/print.php?story=$A[Rid]\"><img src=\"$CONF[G_URL]/images.d/print.gif\" border=\"0\" width=\"15\" height=\"11\" alt=\"" . _PRINTFRIEND . "\" hspace=\"1\" /></a>";
   if ($CONF['MailFriend']) $comments .= " <a href=\"$CONF[G_URL]/friend.php?story=$A[Rid]\"><img src=\"$CONF[G_URL]/images.d/friend.gif\" border=\"0\" width=\"15\" height=\"11\" alt=\"" . _MAILTOFRIEND . "\" hspace=\"1\" /></a>";
	
   $modified = $A['replys'] ? _MODIFIED . " " . KWL_DateFormat($A['lastrdate']) : "";
   $views = _VIEWS . " " . number_format($A["Hits"]);
   $imagedir = "$CONF[G_URL]/backend/template/" . $LAYOUT["TMPL_Summary"] . "/images";
   eval("\$tmp=\"". $template ."\";");
   print $tmp;
}

function KWL_DrawBlock($A) {
   global $LAYOUT;
   static $right_templ, $left_templ;
   $CONF = KWL_GetConf();

   $heading	= KWL_PrepareHtml($A['Heading']);
   $content	= KWL_GetContent($A);
   $date    = !empty($A['Birthstamp']) ? KWL_DateFormat($A['Birthstamp']) : "";

   if ($A['Display']=="l") {
      if (!isset($left_templ)) $left_templ = addslashes(KWL_ReadFile("$CONF[G_PATH]/backend/template/$LAYOUT[TMPL_LeftBlock]/block.tmpl"));
      $imagedir = "$CONF[G_URL]/backend/template/$LAYOUT[TMPL_LeftBlock]/images";
   	eval("\$tmp=\"". $left_templ ."\";");
   } else {
      if (!isset($right_templ)) $right_templ = addslashes(KWL_ReadFile("$CONF[G_PATH]/backend/template/$LAYOUT[TMPL_RightBlock]/block.tmpl"));
      $imagedir = "$CONF[G_URL]/backend/template/$LAYOUT[TMPL_RightBlock]/images";
   	eval("\$tmp=\"". $right_templ ."\";");
   }
   print $tmp;
}

function KWL_DrawMain($A) {
   global $LAYOUT;
   static $template;
   $CONF = KWL_GetConf();

   if (!isset($template)) $template = addslashes(KWL_ReadFile("$CONF[G_PATH]/backend/template/$LAYOUT[TMPL_Main]/main.tmpl"));

   $heading	= $A['Heading'];
   $content	= &$A['Content'];
   $imagedir = "$CONF[G_URL]/backend/template/$LAYOUT[TMPL_Main]/images";
   eval("\$tmp=\"". $template ."\";");
   print $tmp;
}

function KWL_Header() {
   global $LAYOUT,$size,$topic,$login;
   $CONF = KWL_GetConf();

   $ipaddress = $_SERVER['REMOTE_ADDR'];
   list($site_name,$site_slogan) = KWL_PrepareHtml($CONF['SiteName'],$CONF['SiteSlogan']);

   if ($CONF['Banners'] && !$CONF['Banner_location']) $banner = KWL_DrawBanner();
	
   if (!empty($LAYOUT['LogoURL'])) {
      if (!preg_match("/^http/i",$LAYOUT['LogoURL'])) {
         $LAYOUT['LogoURL'] = "$CONF[G_URL]/$LAYOUT[LogoURL]";
      }
      $logo	= "<a href=\"$CONF[G_URL]/\"><img src=\"$LAYOUT[LogoURL]\" alt=\"$site_name - $site_slogan\" border=\"0\" /></a>";
   } else $logo = "<h1>$site_name</h1>\n";

   $searchbox = "<form action=\"$CONF[G_URL]/search.php\" method=\"get\">".
                _FIND ." <input type=\"text\" size=\"$size[find]\" name=\"query\" class='find' /></form>\n";
   
   $date	= strftime($CONF['G_DATE'],time());
	
   $ret = KWL_MakeNavigator("t");
   if (is_array($ret)) {
      $navigation	= "<font color=\"$LAYOUT[NavColor]\">$ret[0]";
      for ($i=1;$i<count($ret);$i++) {
         $navigation .= $CONF['nchar'] . $ret[$i];
      }
      $navigation .= "</font>\n";
   } else unset($navigation);

	$imagedir = "$CONF[G_URL]/backend/template/$LAYOUT[TMPL_Header]/images";
   $template = addslashes(KWL_ReadFile("$CONF[G_PATH]/backend/template/$LAYOUT[TMPL_Header]/header.tmpl"));
   eval("\$tmp=\"". $template ."\";");
   print $tmp;
}

function KWL_Footer() {
   global $LAYOUT,$G_VER;
   $CONF = KWL_GetConf();
   
   $G_URL = $CONF['G_URL'];
   if ($CONF['Banners'] && $CONF['Banner_location']) $banner = KWL_DrawBanner();
	
   $admin = _WEBMASTER . ": <a href=\"$CONF[G_URL]/profiles.php?Author=". urlencode($CONF["SiteOwner"]) . "&amp;AuthorEmail=" . KWL_Rot13($CONF["EmailAddress"]) . "&amp;AuthorURL=" . $CONF['G_URL'] ."\">". htmlspecialchars($CONF["SiteOwner"]) ."</a>";
   
   $copyright = $CONF['Copyright'];
   list($sitename,$siteslogan) = KWL_PrepareHtml($CONF['SiteName'],$CONF['SiteSlogan']);
   $imagedir = "$CONF[G_URL]/backend/template/$LAYOUT[TMPL_Footer]/images";
   $template = addslashes(KWL_ReadFile("$CONF[G_PATH]/backend/template/$LAYOUT[TMPL_Footer]/footer.tmpl"));
   eval("\$tmp=\"". $template ."\";");
   print $tmp;
}

function KWL_DrawComment($A,$where,$fix=0) {
   global $LAYOUT,$cmode,$comment_sort,$login,$user;
   static $template;
   $CONF = KWL_GetConf();

   if (!isset($template)) $template = addslashes(KWL_ReadFile("$CONF[G_PATH]/backend/template/$LAYOUT[TMPL_Comment]/comment.tmpl"));

   $author = KWL_Author($A) . "<a name=\"$A[Rid]\"></a>";
   if (!empty($CONF['SCORING']) && empty($user['config']['noscore'])) $author .= " (" . _SCORE . ": $A[score])";
   if ($A['face']) $face = "<img src=\"$CONF[G_URL]/images.d/face/$A[face]\" border=\"0\" vspace=\"0\" hspace=\"0\" alt=\"$A[face]\" />";
   else $face = "<img src=\"$CONF[G_URL]/images.d/comment.gif\" border=\"0\" vspace=\"0\" hspace=\"0\" alt=\""._COMMENT."\" />";
   
   if ($CONF['SHOW_IP']) $address = "($A[Host])";
   $content	= $fix ? KWL_ParseContent($A['Content'],$A['ParseLevel']) : $A['Content'];
   $content = "<span class=\"comment\">\n". $content ."\n</span>\n";
   $date = KWL_DateFormat($A['Birthstamp']);
   $reply = "";
   if ($A['TopRid'] != $A['ParentRid'] && $cmode == "thread") {
      $sql = "SELECT ParentRid FROM T_Comments WHERE Rid = '$A[ParentRid]'";
      $tmp = SqlResult($sql);
      $reply = "<a title=\"". _VIEW_PARENT ."\" href=\"$CONF[G_URL]/comments.php?rid=$tmp&amp;story=$A[TopRid]&amp;cmode=$cmode&amp;comment_sort=$comment_sort#$A[ParentRid]\">"._VIEW_PARENT."</a> | ";
   }
   $reply .= "<a title=\"". _REPLY ."\" href=\"$CONF[G_URL]/write.php?rid=$A[Rid]&amp;where=$where\">" . _REPLY . "</a>";
   $reply .= " | ";
   if (basename($_SERVER['PHP_SELF']) == "comments.php") $reply .= "<a title=\"". _PARENT ."\" href=\"$CONF[G_URL]/write.php?sid=$A[TopRid]\">" . _PARENT . "</a>";
   else $reply .= "<a title=\"". _PARENT ."\" href=\"$where#comments\">" . _PARENT . "</a>";
   if (!empty($CONF['Bookmark']) && !preg_match("/(pages|pollbooth)\.php/i",$_SERVER['PHP_SELF'])) $reply .= " | <a title=\"". _BOOKMARK ."\" href=\"$CONF[G_URL]/user.php?what=mark&amp;rid=$A[Rid]\">". _BOOKMARK ."</a>";
   if (!empty($CONF['SCORING'])) {
      if ($CONF['admin_login'] || ($login && $user['user_level'] == 2)) {
         $reply .= " | ". _SCORE . ": ";
         $where = urlencode($where);
         if ($A['score'] != 1) $reply .= " [<a href=\"$CONF[G_URL]/submit.php?what=scorechange&amp;rid=$A[Rid]&amp;act=plus\"><b>+</b></a>] ";
         if ($A['score'] != -1)	$reply .= " [<a href=\"$CONF[G_URL]/submit.php?what=scorechange&amp;rid=$A[Rid]&amp;act=minus\"><b>-</b></a>]";
      }
   }
   $reply = "[ $reply ]";
   
   if ($CONF['ENABLE_CEDIT'] && !$CONF['admin_login'] && !$fix && !empty($A['AuthorEmail'])) $content .= "<br /><span class=\"comment-edit\">[<a title=\"". _EDIT ."\" href=\"edit.php?mode=com&amp;rid=$A[Rid]\">". _EDIT ."</a>]</span>";
   if ($fix) $reply = "";
   
	$imagedir = "$CONF[G_URL]/backend/template/$LAYOUT[TMPL_Comment]/images";
   eval("\$tmp=\"". $template ."\";");
   print $tmp;
}

function KWL_ImportLayout($layout) {
   $CONF = KWL_GetConf();
	
   $filename = "$CONF[G_PATH]/backend/layouts/$layout".".xlay";
   if (!file_exists($filename)) {
      $filename = "$CONF[G_PATH]/backend/layouts/". $CONF['Layout'] .".xlay";
   }
   $fpread = fopen($filename,"rb");
   if(!$fpread) KWL_ErrorLog("File Read Error $filename<br>\n");
   else {
      $XLAY	= array();
      while(!feof($fpread) ) {
         $buffer 	= ltrim(chop(fgets($fpread, 256)));
         if ($buffer == "<info>") {
            $author	= ltrim(chop(fgets($fpread, 256)));
            $author = ereg_replace( "<author>", "",$author);
            $author = ereg_replace( "</author>", "",$author);
            $XLAY["Author"] = $author;
            $desc	= ltrim(chop(fgets($fpread, 256)));
            $desc = ereg_replace( "<description>", "",$desc);
            $desc = ereg_replace( "</description>", "",$desc);
            $XLAY["Description"] = $desc;
            $version = ltrim(chop(fgets($fpread, 256)));
            $version = ereg_replace( "<version>", "",$version);
            $version = ereg_replace( "</version>", "",$version);
            $XLAY["Version"] = $version;
         } elseif ($buffer == "<item>") {
            $element = ltrim(chop(fgets($fpread, 256)));
            $value	= ltrim(chop(fgets($fpread, 256)));
				$element = ereg_replace( "<element>", "",$element);
            $element = ereg_replace( "</element>", "",$element);
            $value = ereg_replace( "<value>", "",$value);
            $value = ereg_replace( "</value>", "",$value);
            $XLAY[$element] = $value;
         }
      }
      fclose($fpread);
   }
   return $XLAY;
}

function KWL_DrawBanner() {
   $CONF = KWL_GetConf();
   
   $sql = "SELECT id,url,img_url,alt FROM T_Banners ORDER BY RAND() LIMIT 0,1";
   $A = SqlQueryFetchArray($sql);
   if (is_array($A)) {
      if (!preg_match('!^http!', $A['img_url']))
         $A['img_url'] = "$CONF[G_URL]/$A[img_url]";
      if (empty($A['alt'])) $A['alt'] = $A['url'];
      return "<a href=\"$CONF[G_URL]/redirect.php?what=banner&amp;id=$A[id]".
             "&amp;code=". KWL_HcodeMake("banner".$A['id'],1) ."\" target=\"_blank\"><img src=\"$A[img_url]\" border=\"0\" vspace=\"1\" hspace=\"1\" alt=\"". KWL_PrepareHtml($A['alt']) ."\" /></a>";
   }
}
?>
