CREATE TABLE T_Random_Buttons (
  id int(11) NOT NULL auto_increment,
  url varchar(255) NOT NULL default '',
  img_url varchar(255) NOT NULL default '',
  alt varchar(255) NOT NULL default '',
  hits int(11) NOT NULL default 0,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

CREATE TABLE T_Random_Link (
  id int(11) NOT NULL auto_increment,
  url varchar(255) NOT NULL default '',
  title varchar(255) NOT NULL default '',
  alt varchar(255) NOT NULL default '',
  hits int(11) NOT NULL default 0,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

CREATE TABLE T_Banners (
  id int(11) NOT NULL auto_increment,
  url varchar(255) NOT NULL default '',
  img_url varchar(255) NOT NULL default '',
  alt varchar(255) NOT NULL default '',
  rdate int(11) NOT NULL default 0,
  expire int(11) NOT NULL default 0,
  hits int(11) NOT NULL default 0,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

ALTER TABLE T_Blocks CHANGE URL URL varchar(255);
ALTER TABLE T_Blocks ADD MaxItem tinyint(3) default 10;

ALTER TABLE T_Users DROP mailallow;
ALTER TABLE T_Users DROP rmailallow;
ALTER TABLE T_Users DROP score;
ALTER TABLE T_Users DROP csort;
ALTER TABLE T_Users DROP nocom;
ALTER TABLE T_Users DROP boxes;
ALTER TABLE T_Users DROP blocks;

ALTER TABLE T_Users CHANGE url url varchar(255);
ALTER TABLE T_Users CHANGE profile profile tinytext;
ALTER TABLE T_Users ADD config tinytext NOT NULL default '';
ALTER TABLE T_Users ADD blocks mediumblob NOT NULL default '';
ALTER TABLE T_Users ADD block_key varchar(16) NOT NULL default '';

DELETE FROM T_Stats_hour;
INSERT INTO T_Stats_hour VALUES (0,0),(1,0),(2,0),(3,0),(4,0),(5,0),(6,0),(7,0),(8,0),(9,0),(10,0),(11,0),(12,0),(13,0),(14,0),(15,0),(16,0),(17,0),(18,0),(19,0),(20,0),(21,0),(22,0),(23,0);
