<?
function F_GetBaseURI() {

	if (isset($_SERVER['REQUEST_URI'])) {
		$path = $_SERVER['REQUEST_URI'];
	} else {
		$path = getenv('REQUEST_URI');
	}

	if ((empty($path)) || (substr($path, -1, 1) == '/')) {
		$path = getenv('PATH_INFO');
		if (empty($path)) {
			if (isset($_SERVER['SCRIPT_NAME'])) {
				$path = $_SERVER['SCRIPT_NAME'];
			} else {
				$path = getenv('SCRIPT_NAME');
			}
		}
	}

	$path = preg_replace('/[#\?].*/', '', $path);
	$path = dirname($path);

	if (preg_match('!^[/\\\]*$!', $path)) $path = '';
	return $path;
}

function F_GetBaseURL() {
	if (empty($_SERVER['HTTP_HOST'])) {
		$server = getenv('HTTP_HOST');
	} else {
		$server = $_SERVER['HTTP_HOST'];
	}
	$path = F_GetBaseURI();
	return "http://$server$path/";
}
?>
