<?
/*--------------------------------------------------------------------
   KorWeblog :: Highly Customizable Weblog/CMS
   Copyright (C) 2001-2004 by Im Eunjea <eunjea@kldp.org>
   For detail of license and/or other info, see the file doc/COPYING.
   http://weblog.kldp.org
----------------------------------------------------------------------

LICENSE

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
----------------------------------------------------------------------*/

include("include/common.inc.php");
if (!$CONF['Links']) die(_DISABLED);
$head = _LINKS;
include("include/header.inc.php");

function do_main($node="",$start=0) {
	$A["Heading"] = ucwords(_LINKS);
	$A["Content"] = KWL_NodeWalk($node,0);
	$A["Content"] .= KWL_ShowNodes($node);
	$A["Content"] .= "<br />\n";
	$A["Content"] .= KWL_ShowItems($node,$start);
	$A["Content"] .= KWL_Suggest($node);
	KWL_DrawMain($A);

	if(KWL_CheckAdmin()) { 
		do_admin();
	}
}

function KWL_ListCats($cat) {
   $sql  = "SELECT Rid,Name from T_LinkCats WHERE Verified = '1'";
   $sql  .= " ORDER BY Name";
   $result  = SqlQuery($sql);
   $sel  = $cat=="null" ? "selected" : "";
   $s = "<option value=\"null\" $sel>Top</option>";
   while (list($id,$name) = SqlFetchRow($result)) {
      $sel  = $cat==$id ? "selected" : "";
      $s .= "<option value=\"$id\" $sel>$name</option>\n";
   }
   mysql_free_result($result);
   return $s;
}

function KWL_NodeWalk($startnode="",$linklast=0) { 
	$currnode = $startnode;
   $output = "";
	while(!empty($currnode)) {
		$sql	= "SELECT * from T_LinkCats WHERE Rid='$currnode' AND Verified='1'";
		$result=SqlQuery($sql);
				
		list($id,$name,$currnode) = SqlFetchRow($result);
		if (!empty($name)) {
			if($id != $startnode) {
				$temp = " &gt; <a href=\"". $_SERVER['PHP_SELF'] ."?node=$id\">$name</a>" . $output;
				$output = $temp;
			} else {
				if($linklast == 1) {
					$temp = " &gt; <a href=\"". $_SERVER['PHP_SELF'] ."?node=$id\">$name</a>" . $output;
					$output = $temp;
				} else {
					$temp = " &gt; $name " . $output;
					$output = $temp;
				}
			}
		}
	}
	$temp = "<a href=\"". $_SERVER['PHP_SELF'] ."\">Top</a>" . $output;
	return $temp;
}

function KWL_ShowNodes($node="") { 
   $CONF = KWL_GetConf();

	if ((empty($node)) || ($node=="null")) { 
		$search = "ParentRid='NULL'"; 
	} else {
		$search = "ParentRid='$node'"; 
	}
	$output = "<table cellpadding=2 cellspacing=0 border=0 width=\"100%\">";
	$sql	= "SELECT Rid,Name FROM T_LinkCats WHERE $search and Verified='1' ";
	$sql	.= "AND length(Name) > 1 ORDER BY Name";
	$result = SqlQuery($sql);
	$numrows = mysql_num_rows($result);
	$half = $numrows / 2;
	$count = 0;
	$output .="<tr><td valign=top>\n";
	while($count < $half) { 
		list($id,$name) = SqlFetchRow($result);
		$cnt	= SqlCount("T_Links","CatRid",$id,"Verified","1");
		$output .="$CONF[dotchar]<a href=\"". $_SERVER['PHP_SELF'] ."?node=$id\">$name</a> ($cnt)" . 
			KWL_AdminLinki("T_LinkCats",$id,"links.php?node=$node") . "</li>\n";
		$count++;
	}
	$output .="</td><td valign=top>\n";
	while(list($id,$name) = SqlFetchRow($result)) { 
		$cnt    = SqlCount("T_Links","CatRid",$id,"Verified","1");
		$output .="$CONF[dotchar]<a href=\"". $_SERVER['PHP_SELF'] ."?node=$id\">$name</a> ($cnt)" . 
			KWL_AdminLinki("T_LinkCats",$id,"links.php?node=$node") . "</li>\n";
	}
	$output .="</td></tr></table>";
	return $output;
}

function KWL_ShowItems($node="",$start="") {
	$CONF = KWL_GetConf();
	if ((empty($node)) || ($node=="null"))  { 
		$search = "CatRid = 'NULL'"; 
	} else { 
		$search = "CatRid = '$node'"; 
	}
	$output = "<table width=\"100%\" cellspacing=\"2\">";
	$sql	= "SELECT Rid from T_Links ";
	$sql	.= "WHERE $search and Verified='1'";
	$temp = SqlQuery($sql);
	$total = mysql_num_rows($temp);
	if ($total > 0) { 
		if ($start > 0) { 
			$pr = $start - 26;
			if ($pr < 0) { $pr = 0; }
			$prevlink = "<a href=\"". $_SERVER['PHP_SELF'] ."?node=$node&start=$pr\">[&lt;&lt; " . _PREV . "]</a>";
		}
		if (empty($start)) { $start = 0; }
		$end = $start + 25;
		if ($end > $total) { $end = $total; }
		if ($end < $total) { 
			$nx = $end + 1;
			$nextlink = "<a href=\"". $_SERVER['PHP_SELF'] ."?node=$node&start=$nx\">[" . _NEXT . " &gt;&gt;]</a>";
		}
		$tmp	= $start+1;
		$display = _SHOWING . sprintf(_SHOWING2,$total,$tmp,$end);
		$sql	= "SELECT Rid,Url,Name,Description,Hits ";
		$sql	.= "FROM T_Links ";
		$sql	.= "WHERE $search and Verified='1' ";
		$sql	.= "ORDER BY Name limit $start,25";
		$result = SqlQuery($sql);
		$ck = 0;
		while (list($id,$url,$name,$desc,$hits) = SqlFetchRow($result)) { 
			$tmp	= urlencode($url);
			$output	.= "<tr><td><a href=\"$CONF[G_URL]/portal.php?url=$tmp&what=T_Links&rid=$id&code=". KWL_HcodeMake("T_Links".$id,1) ."\" target=\"_blank\">$name</a> - $url\n";
			if (!empty($desc)) {
				$output	.= "<br />&nbsp;&nbsp;&nbsp;$desc";
			}
#			$output	.= "</td></tr>";
			
			if(KWL_CheckAdmin()) { 
				$output .= "<tr><td><a href=\"". $_SERVER['PHP_SELF'] ."?unapprove=$id\">"
				. "<img src=\"$CONF[img_url]/kill.gif\" BORDER=\"0\">"
				. "</a>&nbsp;<a href=\"". $_SERVER['PHP_SELF'] ."?editlink=$id\">"
				. "<img src=\"$CONF[img_url]/edit.gif\" BORDER=\"0\">"
				. "</a></td></tr>"; 
			}
			$output .="</td></tr>\n";
		}
		$output .= "</table><center>$prevlink $display $nextlink</center>";
	}
	return $output;
}

function KWL_Suggest($node="") {
	global $size;
	$CONF = KWL_GetConf();
	if ($node == "") { $node = "null"; }
	$output	= "<table width=\"100%\">\n";
	$output	.= "<tr><form action=\"". $_SERVER['PHP_SELF'] ."\" method=POST>\n<td align=\"center\">" . _FIND . " <input type=\"text\" name=\"search\" size=" . $size['find'] . "></td></form></tr>\n";
	if ($CONF["Links"]==1 || KWL_CheckAdmin() || $CONF["Links"]==3) {
		$output	.= "<tr><td align=\"center\"><a href=\"". $_SERVER['PHP_SELF'] ."?sugnode=$node\">" . _SUGCAT . "</a> | <a href=\"". $_SERVER['PHP_SELF'] ."?suglink=$node\">" . _SUGLINK . "</a></td></tr>\n";
	}
	$output	.= "</table>";
	return $output;
}

function KWL_SuggestNode($node="") { 
	$output = KWL_NodeWalk($node,1);
	$output .= "<table width=\"100%\">
	<form action=\"". $_SERVER['PHP_SELF'] ."\" name=\"SUGNODE\" method=POST>
	<tr><td width=\"15%\">" . _CATEGORY . ":</td><td><input type=\"text\" name=\"newnode\" size=\"". KWL_FormSize(20) ."\"><input type=\"hidden\" name=\"parent\" value=\"$node\"></td></tr>
	<tr><td></td><td><input type=\"submit\" name=\"addnode\" value=\"" . KWL_SubmitButton() . "\"></td></tr>
	</form>
	</table>";
	return $output;
}
function editlink($node="") {
	global $size;
	$sql	= "SELECT * from T_Links ";
	$sql	.= "WHERE Rid='$node'";
	$result = SqlQuery($sql);
	if (mysql_num_rows($result) < 1) { 
		$output = "No such ID"; 
	} else {
		list($linkid,$catid,$url,$linkname,$desc,$approved,$sname,$semail,$sdate) = SqlFetchRow($result);
		$output = KWL_NodeWalk($catid,1);
		$output .= "<table width=\"100%\" border=0>\n";
		$output	.= "<form action=\"". $_SERVER['PHP_SELF'] ."\" method=POST>\n";
		$output	.= "<tr><td width=\"15%\">" . _SITENAME . ":</td><td><input type=\"text\" name=\"linkname\" size=\"". KWL_FormSize(20) ."\" value=\"$linkname\">\n";
		$output	.= "<input type=\"hidden\" name=\"linkid\" value=\"$linkid\"></td></tr>\n";
		$output	.= "<tr><td width=\"15%\">" . _DESCRIPTION . ":</td><td><input type=\"text\" name=\"description\" size=\"". KWL_FormSize(20) ."\" value=\"$desc\"></td></tr>\n";
		$output	.= "<tr><td width=\"15%\">" . _URL . ":</td><td><input type=\"text\" name=\"url\" size=\"". KWL_FormSize(20) ."\" value=\"$url\"></td></tr>\n";
		$output	.= "<tr><td width=\"15%\">" . _CATEGORY . ":</td><td><select name=\"category\">\n";
		$output	.= KWL_ListCats($catid);
		$output	.= "</select></td></tr>\n";
		$output	.= "<tr><td width=\"15%\">" . _NAME . ":</td><td><input type=\"text\" name=\"subname\" size=\"". $size[name] ."\" value=\"$sname\"></td></tr>\n";
		$output	.= "<tr><td width=\"15%\">" . _EMAIL . ":</td><td><input type=\"text\" name=\"subemail\" size=\"". $size[name] ."\" value=\"$semail\"></td></tr>\n";
		$output	.= "<tr><td>&nbsp;</td><td><input type=\"submit\" name=\"updatelink\" value=\"" . KWL_SubmitButton() . "\"></td></tr>\n";
		$output	.= "</form>\n</table>";
	}
	return $output;
}

function KWL_SuggestLink($node="") {
	global $size,$user;
	$output = KWL_NodeWalk($node,1);
	$output .= "<table width=\"100%\">
	<form action=\"". $_SERVER['PHP_SELF'] ."\" method=POST name=\"Link\">
	<tr><td width=\"15%\">" . _SITENAME . ":</td><td><input type=\"text\" name=\"linkname\" size=\"" . $size[name] . "\" maxlength=64>
	<input type=\"hidden\" name=\"parent\" value=\"$node\"></td></tr>
	<tr><td width=\"15%\">" . _DESCRIPTION . ":</td><td><input type=\"text\" name=\"description\" size=\"" . $size[titl] . "\" maxlength=255></td></tr>
	<tr><td width=\"15%\">" . _URL . ":</td><td><input type=\"text\" name=\"url\" size=\"" . $size[titl] . "\" maxlength=255></td></tr>
	<tr><td width=\"15%\">" . _NAME . ":</td><td><input type=\"text\" name=\"subname\" value=\"" . htmlspecialchars($user[name]) . "\" size=\"" . $size[name] . "\"></td></tr>
	<tr><td width=\"15%\">" . _EMAIL . ":</td><td><input type=\"text\" name=\"subemail\" value=\"" . htmlspecialchars($user[email]) . "\" size=\"" . $size[name] . "\"></td></tr>
	<tr><td></td><td><input type=\"submit\" name=\"addlink\" value=\"" . KWL_SubmitButton() . "\"></td></tr>
	</form>
	</table>";
	return $output;
}

function do_search($keywords="",$start) {
	$CONF = KWL_GetConf();
	$kw = urlencode($keywords);
	$sql	= "SELECT distinct Rid from T_Links ";
	$sql	.= "WHERE (Name like '%$keywords%' ";
	$sql	.= "or Description like '%$keywords%') ";
	$sql	.= "AND Verified='1'";
	$temp  = SqlQuery($sql);
	$total = mysql_num_rows($temp);
	if ($total > 0) {
		$header = "$total ". _LINK_FOUND;
		$output = "<table width=\"100%\" cellspacing=\"2\">";
		if ($start > 0) { 
			$pr = $start - 26;
			if ($pr < 0) { $pr = 0; }
			$prevlink = "<a href=\"". $_SERVER['PHP_SELF'] ."?search=$kw&start=$pr\">[&lt;&lt; " . _PREV . "]</a>";
		}
		if (empty($start)) { $start = 0; }
		$end = $start + 25;
		if ($end > $total) { $end = $total; }
		if ($end < $total) { 
			$nx = $end + 1;
			$nextlink = "<a href=\"". $_SERVER['PHP_SELF'] ."?search=$kw&start=$nx\">[" . _NEXT . " &gt;&gt;]</a>";
		}
		$display = _SHOWING . sprintf(_SHOWING2,$total,$tmp,$end);
		$sql	= "SELECT distinct CatRid,Rid,Url,Name,Description,Hits ";
		$sql	.= "FROM T_Links ";
		$sql	.= "WHERE (Name like \"%$keywords%\" or ";
		$sql	.= "Description like \"%$keywords%\") ";
		$sql	.= "AND Verified='1' ";
		$sql	.= "ORDER BY Name limit $start,25";
		$result = SqlQuery($sql);
		$ck = 0;
		while (list($cat,$id,$url,$name,$desc,$hits) = SqlFetchRow($result)) { 
			$ck++;
			$node = KWL_NodeWalk($cat,1);
			if(($ck % 2) < 1) { 
				$output .= "<tr><td bgcolor=\"#DDDDDD\">"; 
			} else { 
				$output .="<tr><td>"; 
			}
			$tmp	= urlencode($url);
			$output	.= "<a href=\"$CONF[G_URL]/portal.php?url=$tmp&what=T_Links&rid=$id&code=". KWL_HcodeMake("T_Links".$id,1) ."\" target=\"_blank\">$name</a> ($hits) - $url\n";
			if (!empty($desc)) {
				$output	.= "<br />&nbsp;&nbsp;&nbsp;$desc";
			}
			$output	.= "<br />&nbsp;&nbsp;&nbsp;[" . $node . "]";
			if(KWL_CheckAdmin()) { 
				$output .= "<tr><td><a href=\"". $_SERVER['PHP_SELF'] ."?unapprove=$id\">"
				. "<img src=\"$CONF[img_url]/kill.gif\" BORDER=\"0\">"
				. "</a>&nbsp;<a href=\"". $_SERVER['PHP_SELF'] ."?editlink=$id\">"
				. "<img src=\"$CONF[img_url]/edit.gif\" BORDER=\"0\">"
				. "</a></td></tr>";
			}
		}
		$output .= "</table><center>$prevlink $display $nextlink</center>";
	} else { 
		$header = _SEARCHRESULTS;
		$output = _NOMATCHES;
	}
	$A["Heading"]=$header;
	$A["Content"]=$output;
	KWL_DrawMain($A);
	$suggest = KWL_Suggest("");
	$A["Heading"]=_FIND;
	$A["Content"]=$suggest;
	KWL_DrawMain($A);
}

function do_admin() {
	$CONF = KWL_GetConf();
	$sql	= "SELECT * from T_LinkCats ";
	$sql	.= "WHERE Verified='0' ";
	$sql	.= "ORDER BY Name";
    $result = SqlQuery($sql);
	if(mysql_num_rows($result) > 0) {
		$A["Heading"]= _SUBNODE;
		$A["Content"]="<table width=\"100%\" border=0><tr><td valign=top>\n";
		while(list($CatID,$CatName,$CatParent) = SqlFetchRow($result)) {
			$A["Content"] .= "$CatName - (" . KWL_NodeWalk($CatParent,1) .")<br />\n";
			$A["Content"] .= "<a href=\"". $_SERVER['PHP_SELF'] ."?approvenode=$CatID\">"
			. "<img src=\"$CONF[img_url]/verify.gif\" BORDER=\"0\">"
			. "</a> | <a href=\"". $_SERVER['PHP_SELF'] ."?delnode=$CatID\">"
			. "<img src=\"$CONF[img_url]/kill.gif\" BORDER=\"0\">"
			. "</a><hr>";
		}
		$A["Content"] .= "</td></tr></table>";
		KWL_DrawMain($A);
	}
	$sql	= "SELECT * from T_Links ";
	$sql	.= "WHERE Verified='0' ";
	$sql	.= "ORDER BY Name";
	$result = SqlQuery($sql);
	if(mysql_num_rows($result) > 0) { 
		$A["Heading"]= _SUBLINK;
		$A["Content"]="<table width=\"100%\"><tr><td>\n";
		while(list($id,$cat,$url,$name,$desc,$app,$sname,$semail,$sdate) = SqlFetchRow($result)) {
			$A["Content"] .= "<a target=_blank href=\"$url\">$name</a> - (" . KWL_NodeWalk($cat,1) .")<br />\n";
			$A["Content"] .= _DESCRIPTION.": $desc <br />URL: $url<br />"._LINK_SUBMIT_BY.": <a href=\"mailto:$semail\">$sname</a> - $sdate<br />";
			$A["Content"] .= "<a href=\"". $_SERVER['PHP_SELF'] ."?approvelink=$id\">"
			. "<img src=\"$CONF[img_url]/verify.gif\" BORDER=\"0\">"
			. "</a> | <a href=\"". $_SERVER['PHP_SELF'] ."?dellink=$id\">"
			. "<img src=\"$CONF[img_url]/kill.gif\" BORDER=\"0\">"
			. "</a><hr>";
		}
		$A["Content"] .= "</td></tr></table>";
		KWL_DrawMain($A);
	}
}

if (isset($editlink)) {
	$edit = editlink($editlink);
	$A["Heading"]=_LINKS . " " . _EDIT;
	$A["Content"] = $edit;
	KWL_DrawMain($A);

} else if (isset($updatelink)) {
	$url = KWL_UrlCheck($url);
	if (!$url || !$linkname) KWL_ShowError(_ERROR_INPUT);
	else {
	$sql	= "UPDATE T_Links set ";
	$sql	.= "Name='$linkname',";
	$sql	.= "Url='$url',";
	$sql	.= "CatRid='$category',";
	$sql	.= "Description='$description',";
	$sql	.= "SubmitName='$subname',";
	$sql	.= "SubmitEmail='$subemail' ";
	$sql	.= "WHERE Rid='$linkid'";
	$result = SqlQuery($sql);
	KWL_Notice(_LINK_CHANGE_OK);
	}
	do_main();

} else if (isset($unapprove)) {
	$sql	= "UPDATE T_Links set Verified='0' ";
	$sql	.= "WHERE Rid='$unapprove'";
	$result = SqlQuery($sql);
	KWL_Notice(_LINK_DEL_OK);
	do_main();

} else if (isset($approvenode)) { 
	$sql	= "UPDATE T_LinkCats SET Verified='1' ";
	$sql	.= "WHERE Rid='$approvenode'";
	$result=SqlQuery($sql);
	KWL_Notice(_NODE_APP_OK);
	do_main();

} else if (isset($approvelink)) { 
	$sql	= "UPDATE T_Links SET Verified='1' ";
	$sql	.= "WHERE Rid='$approvelink'";
	$result=SqlQuery($sql);
	KWL_Notice(_LINK_APP_OK);
	do_main();

} else if (isset($delnode)) {
	$sql	= "DELETE FROM T_LinkCats ";
	$sql	.= "WHERE Verified='0' ";
	$sql	.= "AND Rid='$delnode'";
	$result=SqlQuery($sql);
	KWL_Notice(_NODE_DEL_OK);
	do_main();

} else if (isset($dellink)) {
	$sql	= "DELETE FROM T_Links ";
	$sql	.= "WHERE Verified='0' ";
	$sql	.= "AND Rid='$dellink'";
	$result=SqlQuery($sql);
	KWL_Notice(_LINK_DEL_OK);
	do_main();

} else if (isset($sugnode)) {
	$A["Heading"] = _ADDSUG;
	$A["Content"] = KWL_SuggestNode($sugnode);
	KWL_DrawMain($A);

} else if (isset($suglink)) { 
	$A["Heading"] = _ADDSUG;
	$A["Content"] = KWL_SuggestLink($suglink);
	KWL_DrawMain($A);

} else if (isset($addnode)) { 
	if(KWL_CheckAdmin()) $appr = 1; 
	else { 
		$appr = 0;
		$tmp = _SUBNODE . " $newnode";
		$title = "$CONF[SiteName] " . _LINKS . " : " . _SUGCAT;
		new email ($title, $tmp, $CONF["SiteName"], "nobody@KorWeblog.Agent", $CONF["EmailAddress"]);
	}
	if ($newnode) {
		$sql	= "INSERT into T_LinkCats ";
		$sql	.= "(Rid,Name,ParentRid,Verified) values ";
		$sql	.= "('" . KWL_getRid() . "','$newnode','$parent','$appr')";
		if (SqlQuery($sql) && !KWL_CheckAdmin()) KWL_Notice(_SUGTHANK);
	}
	do_main($parent);

} else if (isset($addlink)) { 
	$url = KWL_UrlCheck($url);
	if (!$url || !$linkname || !$description) KWL_ShowError(_ERROR_INPUT);
	elseif(SqlCount("T_Links","Url",$url)) KWL_ShowError(_LINKEXIST);
	else {
		if(KWL_CheckAdmin() || $CONF["Links"]==3) $appr = 1;
		else { 
			$appr = 0;
			$tmp = _SITENAME . ": $linkname
URL: $url
". _DESCRIPTION .": $description

". _NAME .": $subname
". _EMAIL .": $subemail
";
			$title = "$CONF[SiteName] " . _LINKS . " : " . _ADDSUG;
			new email ($title, $tmp, $CONF["SiteName"], "nobody@KorWeblog.Agent", $CONF["EmailAddress"]);
		}
			
		$sql	= "INSERT into T_Links ";
		$sql	.= "(Rid,CatRid,Url,Name,Description,Verified,Hits,";
		$sql	.= "SubmitName,SubmitEmail,SubmitDate) values ";
		$sql	.= "('" . KWL_getRid() . "','$parent','$url','$linkname','$description',";
		$sql	.= "'$appr',0,'$subname','$subemail',now())";
		$tmp = SqlQuery($sql);
		if($CONF["Links"] == 1) KWL_Notice(_SUGTHANK);
	}
	do_main($parent);

} else if (isset($search)) { 
	do_search($search,$start);

} else {
   settype($node, "string");
   settype($start, "string");
	do_main($node,$start);
}
include("include/footer.inc.php");
?>
