<?
/*--------------------------------------------------------------------
   KorWeblog :: Highly Customizable Weblog/CMS
   Copyright (C) 2001-2004 by Im Eunjea <eunjea@kldp.org>
   For detail of license and/or other info, see the file doc/COPYING.
   http://weblog.kldp.org
----------------------------------------------------------------------

LICENSE

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
----------------------------------------------------------------------*/

include("include/common.inc.php");

settype($what, "string");
settype($act, "string");
$location = isset($_GET['location']) ? $_GET['location'] : "";
switch ($what) {

   case "login":
      if (KWL_CheckUserPasswd($name,$passwd)) {
         $tmp = KWL_GetUserInfo("name",$name);
         if (isset($_POST['remember'])) $c_time = $CONF['Cookie_time'] * 86400;
         else $c_time = 0;
         $code = KWL_HcodeMake($tmp['uid'].$tmp['name'].$tmp['pass']);
         KWL_DoCookie("kwebloguser", "$tmp[uid]:$tmp[name]:$tmp[pass]:$code",$c_time);
         if (preg_match("/login\.php/i",$_POST['location'])) $_POST['location'] = "/";
         KWL_RedirectNotice(sprintf(_START_LOGIN,$name),$_POST['location'],1);
      } else KWL_ShowError(_PASS_NO);
   break;

   case "lostpass":
      if (KWL_CheckUserName($name)) $user = KWL_GetUserInfo("name",$name);
      if (KWL_EmailCheck($email)) $user = KWL_GetUserInfo("email",$email);
      if (empty($user['name'])) KWL_ShowError(_NO_USER);
      else {
         $pass = KWL_MakePasswd();
         $email = $user['email'];
         $sql  = "UPDATE T_Users SET pass = '". crypt($pass) ."' ";
         $sql .= "WHERE uid = '$user[uid]'";
         if (SqlQuery($sql)) {
            KWL_MailToUser($user['name'],$pass,$email);
            $head = _LOGIN;
            include("include/header.inc.php");
            $VAR['Content'] = "<center><b>". _NEW_USER_DESC ."</b>".
                            "<p />[ <a href=\"$G_URL\">".
                            KWL_PrepareHtml($CONF['SiteName']) ."</a> - ".
                            KWL_PrepareHtml($CONF['SiteSlogan']) ." ]</center><br />";
            $VAR['Heading'] = _UHOME;
            KWL_DrawMain($VAR);
            include("include/footer.inc.php");
            exit;
         } else KWL_ShowError(_SQL_ERROR);
      }
   break;

   case "newuser":
      $name = trim($name);
      KWL_CheckNewUser($name,$email);
      if (!$CONF['regist_check_email']) {
         $welcome = _NEW_USER_DESC1;
         if (!empty($passwd) || !empty($passwd1)) {
            if ($passwd == $passwd1) $pass = $passwd;
            else KWL_ShowError(_PASSWORD_DISMATCH);
         } else KWL_ShowError(_PASSWORD_DISMATCH);
      } else {
         $welcome = _NEW_USER_DESC;
         $pass = KWL_MakePasswd();
      }
      $cpass = crypt($pass);
      $sql  = "INSERT INTO T_Users (uid, user_level, name, pass, email, rdate) ";
      $sql .= "VALUES ('', 0, '$name', '$cpass', '$email', now())";
      SqlQuery($sql);
      if (SqlInsertId()) {
         KWL_MailToUser($name,$pass,$email);
         $head = _LOGIN;
         include("include/header.inc.php");
         $VAR['Content'] = "<center><b>$welcome</b>".
                         "<p />[ <a href=\"$CONF[G_URL]\">".
                         KWL_PrepareHtml($CONF['SiteName']) ."</a> - ".
                         KWL_PrepareHtml($CONF['SiteSlogan']) ." ]</center><br />";
         $VAR['Heading'] = _UHOME;
         KWL_DrawMain($VAR);
         include("include/footer.inc.php");
         exit;
      } else KWL_ShowError(_SQL_ERROR);
   break;
}

$head = _UREGITER;
include("include/header.inc.php");
$out = new KWL_Html;

if ($act == "foo") {
   if (!$CONF['regist_check_email']) $lpass_txt = _LPASS_TXT1;
   else $lpass_txt = _LPASS_TXT;

$VAR['Heading'] = _LOST_PASS;
$VAR['Content'] = $out->form_start("login.php","login") .
                  $out->table_start("100%",'',0,0,3) .
"<tr>
   <td colspan=\"2\">$lpass_txt</td>
</tr>   
<tr>
   <td>* ". _NAME .":</td>
   <td>". $out->input_form("text","name",'',KWL_FormSize(15),50) ."</td>
</tr>";

if (!$CONF['regist_check_email']) $VAR['Content'] .= "
<tr>
   <td>* ". _EMAIL .":</td>
   <td>". $out->input_form("text","email",'',KWL_FormSize(15),50) ."</td>
</tr>";

$VAR['Content'] .= "
<tr>
   <td colspan=\"2\">".
   $out->input_form("hidden","what","lostpass") .
   $out->input_form("submit",'',KWL_SubmitButton()) . "</td>
</tr>". $out->table_end() . $out->form_end();
KWL_DrawMain($VAR);
}

$VAR['Heading'] = _UREGITER;
$VAR['Content'] = $out->form_start("login.php","register") .
                $out->table_start("100%",'',0,0,3) .
"<tr>
   <td>". _NAME .":</td>
   <td>". $out->input_form("text","name",'',KWL_FormSize(15),35) ."
   [ <a href=\"{$CONF['G_URL']}/id_check.php\" onclick=\"new_windows('{$CONF['G_URL']}/id_check.php','checkid',1,1,500,200); return false\">". _DUP_CHECK ."</a> ]</td>
</tr>
<tr>
   <td>". _EMAIL .":</td>
   <td>". $out->input_form("text","email",'',KWL_FormSize(15),60) ."</td>
</tr>";

if (!$CONF['regist_check_email']) {
   $VAR['Content'] .= "
<tr>
   <td>". _PASSWORD .":</td>
   <td>". $out->input_form("password","passwd",'',KWL_FormSize(15),10) ."</td>
</tr>
<tr>
   <td>". _PASSWORD1 .":</td>
   <td>". $out->input_form("password","passwd1",'',KWL_FormSize(15),10) ."</td>
</tr>
<tr>
   <td colspan=\"2\">(". _REG_TEXT1 .")</td>
</tr>";
} else {
   $VAR['Content'] .= "
<tr>
   <td colspan=\"2\">(". _REG_TEXT .")</td>
</tr>";
}
$VAR['Content'] .= "
<tr>
	<td colspan=\"2\">".
   $out->input_form("hidden","what","newuser") .
   $out->input_form("submit",'',KWL_SubmitButton()) ."</td>
</tr>". $out->table_end() . $out->form_end();
KWL_DrawMain($VAR);

$VAR['Heading'] = "<a name=\"login\">". _LOGIN ."</a>";
$VAR['Content'] = $out->form_start("login.php","login") .
                $out->table_start("100%",'',0,0,3) .
"<tr>
   <td>". _NAME .":</td>
   <td>". $out->input_form("text","name",'',KWL_FormSize(15),50) ."</td>
<tr>
   <td>". _PASSWD .":</td>
   <td>". $out->input_form("password","passwd",'',KWL_FormSize(15),13) ."<br />".
          $out->check_box("remember") . _REMEBERME ."
   </TD>
<tr>
   <td colspan=\"2\">".
   $out->input_form("hidden","what","login") .
   $out->input_form("hidden","location",$location) .
   $out->input_form("submit",'',_LOGIN) ."</td>";

if ($act != "foo") $VAR['Content'] .= "<tr><td colspan=\"2\">(<a href=\"$CONF[G_URL]/login.php?act=foo\">". _LOST_PASS ."</a>)</td>";
$VAR['Content'] .= "</tr>". $out->table_end() . $out->form_end();
KWL_DrawMain($VAR);

include("include/footer.inc.php");
?>
