<?
/*--------------------------------------------------------------------
   KorWeblog :: Highly Customizable Weblog/CMS
   Copyright (C) 2001-2004 by Im Eunjea <eunjea@kldp.org>
   For detail of license and/or other info, see the file doc/COPYING.
   http://weblog.kldp.org
----------------------------------------------------------------------

LICENSE

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
----------------------------------------------------------------------*/

include("include/common.inc.php");

/* watch stories */
if ($login && $CONF['Story_Watch']) {
   settype($_GET['watch'],"string");
   if (!empty($_GET['story'])) {
      if (empty($_GET['location'])) $locate = "{$CONF['G_URL']}/stories.php?story={$_GET['story']}";
      else $locate = rawurldecode($_GET['location']);
      
      if ($_GET['watch'] == "on") {
         if (SqlCount("T_Stories_watch","rid",$_GET['story'],"uid",$user['uid'])) {
            SqlQuery("UPDATE T_Stories_watch SET watch = 1 WHERE rid = '{$_GET['story']}' AND uid = '{$user['uid']}'");
         } else {
            SqlQuery("INSERT INTO T_Stories_watch values ('{$_GET['story']}', '{$user['uid']}', 1)");
         }
         KWL_RedirectNotice(_START_WATCHING_STORY,$locate,1);
      } elseif ($_GET['watch'] == "off") {
         SqlQuery("DELETE FROM T_Stories_watch WHERE rid = '{$_GET['story']}' AND uid = '{$user['uid']}'");
         KWL_RedirectNotice(_STOP_WATCHING_STORY,$locate,1);
      }
   }
}

include("include/header.inc.php");

settype($page, "integer");
settype($p, "integer");
if (empty($page)) $page = 1;
if (empty($p)) $p = 1;

if (empty($story)) {
   if (empty($_SERVER['QUERY_STRING'])) KWL_AdminMsg();
   $page_start = ($CONF["LimitNews"] * $page) - $CONF["LimitNews"]; 
   $sql	= "SELECT * FROM T_Stories WHERE ";
   if ($CONF["Moderation"]) $sql	.= " Verified = 'Y' AND ";
   if ($CONF["Topics"] && !empty($topic)) $sql .= " Topic = '$topic' AND ";
   if (empty($user['config']['r_sort'])) $story_sort = "Repostamp";
   else $story_sort = "lastrdate";
   $sql	.= " Rid > '0' ORDER BY $story_sort desc";
   $sql	.= sprintf(" LIMIT %s,%s",$page_start,$CONF["LimitNews"]);

   $result	= SqlQuery($sql);
   if (mysql_num_rows($result)) {
      while ($A = mysql_fetch_array($result)) {
         KWL_DrawSummary($A,urlencode("stories.php?story=" . $A['Rid']));
         
      }
      if ($topic) $num_rows = SqlCount("T_Stories","Topic",$topic,"Verified","Y");
      else $num_rows = $TOTAL_STORY;

      $blah = KWL_npLink($num_rows,$page,"stories.php?topic=$topic",$CONF["LimitNews"]);
      if (!empty($blah)) echo "<center>$blah</center>\n";
      
   } else {
      
      $bla	= isset($TOPIC[$topic]['Topic']) ? $TOPIC[$topic]['Topic'] : "";
      if (empty($bla)) $bla = _NOSTORY;
      $VAR["Heading"] = $bla;
      if ($CONF["Topics"]>0 && !empty($topic)) $tmp	= _EMPTYTOPIC;
      else $tmp	= _EMPTY;
      $VAR["Content"] = $tmp . "<br /><br />";
      KWL_DrawMain($VAR);
   }

} else {

   if (!empty($C_STORY)) $A = &$C_STORY;
   else $A = KWL_GetStory($story);

   if (!is_array($A)) {

      $VAR["Heading"] = _NOSTORY;
      $VAR["Content"] = "<br /><center><b>". _NOSTORY1
                        ."</b><p />[ <a href=\"$CONF[G_URL]\">"
                        . KWL_PrepareHtml($CONF['SiteName']) ."</a> - "
                        . KWL_PrepareHtml($CONF['SiteSlogan']) ." ]</center><br />";
      KWL_DrawMain($VAR);

   } else {

      $tmp	= urlencode("stories.php?story=" . $A["Rid"]);
      if ($p<2 && !isset($hide)) KWL_DrawStory($A,$tmp);
      if ($CONF['NEXT_PREV']) echo KWL_NP_Story($A['Repostamp'],$topic);

	   if (!$CONF['NoLogin_User'] && empty($user['name']) && $A['replys']) {
         if ($tmp = KWL_ReadFile("$CONF[G_PATH]/logs/story_lst.txt")) {
            $story_array = preg_split("/(?:\r\n|\r|\n)/", $tmp);
            if (in_array($story, $story_array)) {
               $TOPIC[$A['Topic']]['NoComments'] = true;
               $VAR["Heading"] = _ANTIREAD;
               $VAR["Content"] = "<br /><center>". _ANTIREAD1 ."</center><br />";
               KWL_DrawMain($VAR);
            }
         }
      }
      
      if (!$TOPIC[$A['Topic']]['NoComments']) {
         if (!empty($user['config']['nocom']) && $A['replys']) {
            echo "<p />\n<center>[ " . _COMMENT ." ". $A['replys'] ." ". _FIX ." : "
               . "<a href=\"$CONF[G_URL]/comments.php?rid=$A[Rid]&story=$A[Rid]\">"
               . _REPLY_VIEW . "</a> ]</center><br />\n";
         } else {
            if (($A['replys'] && $CONF['Comments']) || $trackback) {
               $topinfo['title'] = $A['Heading'];
               $topinfo['renum'] = $A['replys'];
               $topinfo['Rid'] = $A['Rid'];
               if (!empty($CONF['SCORING'])) {
                  $tmp = KWL_GetScore($A['Rid']);
                  $topinfo['renum0'] =& $tmp['C0'];
                  $topinfo['renum1'] =& $tmp['C1'];
               }

               if ($CONF['PAGE_REPLY']) {
                  KWL_PageReply($story,"stories.php?story=$A[Rid]",$topinfo,$score);
               } else {
                  KWL_SortComment("comments.php?rid=$A[Rid]&story=$A[Rid]",1,$topinfo);

                  if ($CONF['tbmsg_show'] && $trackback) { include_once("include/tb_msgs.php"); }
                  
                  KWL_doComments($story,$story,"stories.php?story=$A[Rid]&cmode=$cmode&comment_sort=$comment_sort&p=$p" ,0);
                  KWL_SortComment("comments.php?rid=$A[Rid]&story=$A[Rid]",1,$topinfo);
               }
            }
            print "<p />\n";
            KWL_PostComment($story,$story,"stories.php?story=$A[Rid]&p=$p");
         }
      }
      if ($A['Host'] != KWL_GetIP()) KWL_UpHits("T_Stories",$story);

      /* watch stories */
      if ($login && $CONF['Story_Watch']) {
         $tmp = "\n<a class=\"story_watch\" href=\"$CONF[G_URL]/stories.php?watch=";
         $back_url = rawurlencode($_SERVER['PHP_SELF'] ."?". $_SERVER['QUERY_STRING']);
         $watch = SqlResult("SELECT watch FROM T_Stories_watch WHERE rid = '$story' AND uid = '{$user['uid']}'");
         if (!$watch) {
            $tmp .= "on&amp;story=$story&amp;location=$back_url\">". _START_WATCHING_STORY;
         } else {
            $tmp .= "off&amp;story=$story&amp;location=$back_url\">". _STOP_WATCHING_STORY;
            /* already sent notice so update status */
            if ($watch == 3) SqlQuery("UPDATE T_Stories_watch SET watch = 1 WHERE rid = '$story' AND uid = '{$user['uid']}'");
         }
         echo $tmp . "</a><br />\n";
      }
   }
}

/* Display Online User */
if (!$CONF['NoLogin_User'] && $CONF['Show_Online_User'] && empty($story)) {
   echo "<br />";
   $last_regit_user = SqlQueryFetchArray("SELECT * FROM T_Users ORDER BY rdate DESC LIMIT 1");
   $total_user = number_format(SqlCount("T_Users"));
   $online = KWL_SessionGetOnline();
   $VAR['Content'] = sprintf(_ONLINE_USER_INFO1, $total_user);
   $VAR['Content'] .= sprintf(_ONLINE_USER_INFO2,"<a href=\"{$CONF['G_URL']}/profiles.php?uid={$last_regit_user['uid']}\">". htmlspecialchars($last_regit_user['name']) . "</a>");
   
   $expire_time = time() - ($CONF['Session_tmout'] * 60);
   $ret = SqlQuery("SELECT uid FROM T_Session WHERE lastused > $expire_time AND uid > 0");
   $hide_count = 0;
   $ass = "";
   
   if (mysql_num_rows($ret)) {
      while ($A = mysql_fetch_array($ret)) {
         $online_user = KWL_GetUserInfo("uid",$A['uid']);
         $hide_user = unserialize($online_user['config']);
         if (!empty($hide_user['hide'])) {
            $hide_count++;
         } else {
            $ass .= "<a href=\"{$CONF['G_URL']}/profiles.php?uid={$A['uid']}\">".
               htmlspecialchars($online_user['name']) . "</a> ";
         }
      }   
   }
   
   $VAR['Content'] .= sprintf(_ONLINE_USER_INFO3, $online[1] + $online[0], $online[1] - $hide_count, $hide_count, $online[0]);
   $VAR['Content'] .= sprintf(_ONLINE_USER_INFO4,$CONF['Session_tmout']) . $ass;

   $VAR['Heading'] = _ONLINE_USER_INFO_TITLE;
   $VAR['Content'] = "<div class=\"online_user\">\n". $VAR['Content'] . "</div>\n";
   KWL_DrawMain($VAR);
}

include("include/footer.inc.php");

function KWL_AdminMsg() {
   $sql = "SELECT * FROM T_Admin_Msg WHERE Active = 1 AND Expire > ". time() ." ORDER BY Rid DESC";
   $result = SqlQuery($sql);
   if (mysql_num_rows($result)) {
      while ($A = mysql_fetch_array($result)) {
         if (!$A['Type']) $A['Content'] = KWL_ParseContent($A['Content'],3);
         KWL_DrawMain($A);
      }
   }
}
?>
