<?
/*--------------------------------------------------------------------
   KorWeblog :: Highly Customizable Weblog/CMS
   Copyright (C) 2001-2004 by Im Eunjea <eunjea@kldp.org>
   For detail of license and/or other info, see the file doc/COPYING.
   http://weblog.kldp.org
----------------------------------------------------------------------

LICENSE

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
----------------------------------------------------------------------*/

include("../include/common.inc.php");
include("auth.inc.php");
$phtmltag = PossibleHTMLTags();

if (isset($save)) {
   if (is_array($htmltag)) {
      unset($cook);
      foreach ($htmltag as $k=>$v) {
         if (in_array($k,$phtmltag)) $cook[] = $k;
      }
      $cook = serialize($cook);
      if (SqlCount("T_Config","Name","HtmlKey"))
         $sql = "UPDATE T_Config SET Value = '$cook' WHERE Name = 'HtmlKey'";
      else
         $sql = "INSERT INTO T_Config (Name,Value) VALUES ('HtmlKey','$cook')";

      if (SqlQuery($sql)) {
         KWL_Redirect("admin/htmltag.php?msg=".urlencode(_SAVED),0);
      } else KWL_ShowError(_SQL_ERROR);
   } else {
      KWL_ShowError(_HTML_OPTION1);
   }
} else {

$out = new KWL_Html;
$current = KWL_GetConf('HtmlKey');

$VAR['Content'] = $out->form_start("admin/htmltag.php","htmltag")
. $out->table_start("350","center",1,0,3) ."
<TR>
   <TH>HTML Tag</TH> <TH>&nbsp;</TH>";

foreach ($phtmltag as $tag) {
   if (in_array($tag,$current)) $check = 1;
   else $check = 0;   
   $VAR['Content'] .= "<TR>".
                    "<TD>&lt;". strtoupper($tag) ."&gt;</TD>".
                    "<TD>". $out->check_box("htmltag[$tag]",$check).
                    "</TD>\n</TR>";
}
$VAR['Content'] .= "<TR><TD COLSPAN=2 ALIGN=CENTER>".
                 $out->input_form("submit","save",_SAVE_CHANGE) .
                 "</TD></TR>";
    
$VAR['Content'] .= "</TR>". $out->table_end() . $out->form_end();
$VAR['Heading'] = _HTML_OPTION;

$head = "html tag";
include("../include/header.inc.php");
KWL_DrawMain($VAR);
include("../include/footer.inc.php");
}

function PossibleHTMLTags() {
   return array('a', 'b', 'blockquote', 'br', 'center', 'div', 'em', 'font',
                'hr', 'i', 'img', 'li', 'marquee', 'ol', 'p', 'pre', 'script',
                'span', 'strong', 'tt', 'ul', 'table', 'td', 'th', 'tr');
}
?>
