<?
/*--------------------------------------------------------------------
   KorWeblog :: Highly Customizable Weblog/CMS
   Copyright (C) 2001-2004 by Im Eunjea <eunjea@kldp.org>
   For detail of license and/or other info, see the file doc/COPYING.
   http://weblog.kldp.org
----------------------------------------------------------------------

LICENSE

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
----------------------------------------------------------------------*/

include("../include/common.inc.php");
include("auth.inc.php");

set_time_limit(0);
ini_set('max_execution_time',0);

function KWL_Update_Replys($rid) {
	if (SqlCount("T_Stories","Rid",$rid)>0) {
		$replys = SqlCount("T_Comments","TopRid",$rid);
		$sql  = "SELECT Birthstamp FROM T_Comments WHERE TopRid = '$rid' ";
		$sql .= "ORDER By Birthstamp desc LIMIT 1";
		$lastrdate = SqlResult($sql);
		SqlQuery("LOCK TABLES T_Stories WRITE");
		SqlQuery("UPDATE T_Stories SET replys = $replys, lastrdate = '$lastrdate' WHERE Rid = '$rid'");
		SqlQuery("UNLOCK TABLES");
	}
}

function KWL_KillChild($table,$item,$toprid=0) {
	global	$where;

	$sql	= "SELECT Rid FROM $table WHERE ParentRid = '$item'";
	$result	= SqlQuery($sql);
	if ($result<1) { KWL_ErrorLog(_UNABLE_SELECT . " $table."); }

	if (!$toprid) {
	 $toprid = SqlResult("SELECT TopRid FROM T_Comments WHERE Rid = '$item'");
	}

	for ($i=0;$i<mysql_num_rows($result);$i++) {
		$_rid	= mysql_result($result, $i);
		$sql	= "DELETE FROM $table WHERE Rid = '" . $_rid . "'";
		$RET	= SqlQuery($sql);
		KWL_AccessLog(_DELETE_ITEM . " $_rid : Table = $table");
		if ($RET<1) { 
			KWL_ErrorLog(_UNABLE_DEL . "$_rid : Table =  $table"); 
		} else {
			KWL_KillChild($table,$_rid,$toprid);			
		}
	}
	
	$sql	= "DELETE FROM $table WHERE Rid = '$item'";
	$RET	= SqlQuery($sql);
	if ($RET<1) { 
		KWL_ErrorLog(_UNABLE_DEL . " $item : Table = $table");
	} else {
		KWL_Update_Replys($toprid);
	}
}

if ($what=="T_Comments") {

	KWL_KillChild("T_Comments",$item);
	KWL_Redirect("$where");
	exit();

} elseif ($what=="T_Stories") {

	# ε  ִ  
	$result = SqlQuery("SELECT * FROM T_Stories WHERE Rid = '$item'");
	$A = mysql_fetch_array($result);
	if (!empty($A['bofile'])) {
		@unlink("$CONF[G_PATH]/upload/$A[Topic]/$A[bcfile]/$A[bofile]");
      @unlink("$CONF[G_PATH]/upload/$A[Topic]/$A[bcfile]/$A[bofile]"."_t.jpg");
		@rmdir("$CONF[G_PATH]/upload/$A[Topic]/$A[bcfile]");
	}

	/*==   ==*/
	$sql	= "DELETE FROM T_Stories WHERE Rid = '$item'";
	$RET	= SqlQuery($sql);
	KWL_AccessLog(_DEL_STORY . " $item");
	if ($RET<1) {
		KWL_ErrorLog(_UNABLE_DEL . " $item");
	}
	$sql	= "DELETE FROM T_Comments ";
	$sql	.= "WHERE TopRid = '$item'";
	$RET	= SqlQuery($sql);
	KWL_AccessLog(_DEL_REPLY . " $item");
	if ($RET<1) {
		KWL_ErrorLog(_UNABLE_DEL . " $item");
	}
	$sql	= "DELETE FROM T_IndexLinks ";
	$sql	.= "WHERE ParentRid = '$item'";
	$RET	= SqlQuery($sql);
	KWL_AccessLog(_DELETE_ITEM . " $item");
	if ($RET<1) {
		KWL_ErrorLog(_UNABLE_DEL . " $item");
	}
	KWL_ExportRdf();
	if (eregi("stories.php",$where)) $where = "";
	KWL_Redirect("$where");
	exit();

} elseif ($what=="T_PollQuestions") {

	/*== destroy record ==*/
	$sql	= "DELETE FROM T_PollQuestions ";
	$sql	.= "WHERE Rid = '$item'";
	$RET	= SqlQuery($sql);
	KWL_AccessLog(_DEL_POLL . " $item");
	if ($RET<1) {
		KWL_ErrorLog(_UNABLE_DEL . " $item");
	}
	$sql	= "DELETE FROM T_PollAnswers ";
	$sql	.= "WHERE Rid = '$item'";
	$RET	= SqlQuery($sql);
	if ($RET<1) {
		KWL_ErrorLog(_UNABLE_DEL . " $item");
	}
	$sql	= "DELETE FROM T_Comments ";
	$sql	.= "WHERE TopRid = '$item'";
	$RET	= SqlQuery($sql);
	if ($RET<1) {
		KWL_ErrorLog(_UNABLE_DEL . " $item");
	}
	KWL_Redirect("$where");
	exit();

} elseif ($what=="T_Topics") {

	/* get array of stories */
	$sql	= "SELECT Rid FROM T_Stories ";
	$sql	.= "WHERE Topic = '$item'";
	$result	= SqlQuery($sql);
	if ($result<1) {
		KWL_ErrorLog(_UNABLE_SELECT . " $item");
	}
	$cid	= array();
	for ($i=0;$i<mysql_num_rows($result);$i++) {
		$cid[$i]	= mysql_result($result, $i);
	}

	/*  鵵  */
	$sql	= "DELETE FROM T_Comments WHERE ";
	for ($i=0;$i<sizeof($cid);$i++) {
		$sql	.= sprintf("TopRid = '%s' OR ",$cid[$i]);
	}
	$sql	.= "Rid = 'NULL'";
	$RET	= SqlQuery($sql);
	if ($RET<1) {
		KWL_ErrorLog(_UNABLE_DEL);
	}

	/* ε ũ  */
	$sql	= "DELETE FROM T_IndexLinks WHERE ";
	for ($i=0;$i<sizeof($cid);$i++) {
		$sql	.= sprintf("ParentRid = '%s' OR ",$cid[$i]);
	}
	$sql	.= "ParentRid = 'NULL'";
	$RET	= SqlQuery($sql);
	if ($RET<1) {
		KWL_ErrorLog(_UNABLE_DEL);
	}

	/* ش    */
	$sql	= "DELETE FROM T_Stories ";
	$sql	.= "WHERE Topic = '$item'";
	$RET	= SqlQuery($sql);
	if ($RET<1) {
		KWL_ErrorLog(_UNABLE_DEL);
	}

	/*   */
	$sql	= "DELETE FROM T_Topics ";
	$sql	.= "WHERE Rid = '$item'";
	$RET	= SqlQuery($sql);
	KWL_AccessLog(_DEL_TOPIC . " $item");
	if ($RET<1) {
		KWL_ErrorLog(_UNABLE_DEL . " $item");
	}

	KWL_ExportRdf();
	KWL_Redirect("admin/topics.php");
	exit();

} elseif ($what=="T_LinkCats") {

	KWL_KillChild("T_LinkCats",$item);
	KWL_AccessLog(_DEL_CATE . " $item");
	KWL_Redirect("links.php");
	exit();

} elseif ($what=="T_Blocks") {

	$sql	= "DELETE FROM $what ";
	$sql	.= "WHERE Rid = '$item'";
	$RET	= SqlQuery($sql);
	KWL_AccessLog(_DELETE_ITEM . " $item : Table = $what");
	if ($RET<1) {
		KWL_ErrorLog(_UNABLE_DEL . " $item : $what");
	}
	$sql	= "DELETE FROM T_Comments ";
	$sql	.= "WHERE TopRid = '$item'";
	$RET	= SqlQuery($sql);
	if ($RET<1) {
		KWL_ErrorLog(_UNABLE_DEL . " $item");
	}
	if ($CONF['File_Cache']) KWL_KillCacheFile($item);

} else {

	/*== destroy anything else ==*/
	$sql	= "DELETE FROM $what ";
	$sql	.= "WHERE Rid = '$item'";
	$RET	= SqlQuery($sql);
	KWL_AccessLog(_DELETE_ITEM . " $item : Table = $what");
	if ($RET<1) {
		KWL_ErrorLog(_UNABLE_DEL . " $item : $what");
	}

}
KWL_Redirect("$where");
?>
