<?
/*--------------------------------------------------------------------
   KorWeblog :: Highly Customizable Weblog/CMS
   Copyright (C) 2001-2004 by Im Eunjea <eunjea@kldp.org>
   For detail of license and/or other info, see the file doc/COPYING.
   http://weblog.kldp.org
----------------------------------------------------------------------

LICENSE

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
----------------------------------------------------------------------*/

include("../include/common.inc.php");
include("auth.inc.php");
include("../include/header.inc.php");

$dir	= $CONF['G_PATH'] . "/backend/template/";
$ldir	= $CONF['G_PATH'] . "/backend/layouts/";

function KWL_GetTmpl($what,$value) {
	global	$dir,$LAYOUT;
   $CONF = KWL_GetConf();

	$handle=opendir($dir);
	$s		= "";
	while ($file = readdir($handle)) {
		$tmpl	= $dir . $file . "/" . $what . ".tmpl";
		if ($file != "." && $file != ".." && file_exists($tmpl)) {
			$foo	= $LAYOUT[$value]==$file ? "selected" : "";
			$s .= sprintf("<option value=\"%s\" %s>%s</option>\n",$file,$foo,$file);
		}
	}
	closedir($handle);
	return	$s;
}

	$VAR["Heading"] = _LAYOUT_EDITOR . " \"$site_theme\"";

	$VAR["Content"] = "
<table
	cellpadding	= 2
	cellspacing	= 1
	border	= 0
	width	= 100%>

<tr>
<td	colspan	= 4
	align	= center>
<form	action	= \"$CONF[G_URL]/admin/submit.php\"
	method	= POST
	name	= \"Layout\">
". _NAME .":
<select name=\"name\">";

	$handle=opendir($CONF['G_PATH'] . "/backend/layouts");
	while ($file = readdir($handle)) {
		$tmp    = substr($file,-5,5);
		$name   = eregi_replace(".xlay", "", $file);
		$crap	= !empty($preview_layout) ? $preview_layout : $site_theme;
		if ($file != "." && $file != ".." && strtolower($tmp) == ".xlay") {
			$foo    = ($name==$crap) ? "selected" : "";
			$VAR["Content"] .= sprintf("<option value=\"%s\" %s>%s</option>\n",$name,$foo,$name);
		}
	}
	closedir($handle);

$VAR["Content"] .= "
</select>
<input	type	= text
	name	= Layout
	value	= \"$site_theme\"
	size=" . KWL_FormSize(13) ."
	maxlength=12>
<input	type	= hidden
	name	= \"what\"
	value	= \"layout\">
<input	type	= submit
	name	= \"layout_mode\"
	value	= \"View/Load\">
&nbsp;&nbsp;&nbsp;
<input	type	= submit
	name	= \"layout_mode\"
	value	= \"Kill\">
<input	type	= submit
	name	= \"layout_mode\"
	value	= \"Add/Update\">
</td>
</tr>

<tr>
<td colspan=4><h3>"._LAYOUT_EDITOR." (XLAY)</h3>
($ldir)</td>
</tr>

<tr>
<td>"._LAYOUT_AUTHOR."</td>
<td 	colspan = 3><input type=text name=Author size=" . KWL_FormSize(13) ." maxlength=24 value=\"" . $LAYOUT["Author"] . "\"></td>
</tr>

<tr>
<td>"._LAYOUT_DESC."</td>
<td 	colspan = 3><input type=text name=Description size=" . KWL_FormSize(13) ." maxlength=96 value=\"" . $LAYOUT["Description"] . "\"></td>
</tr>

<tr>
<td>"._LAYOUT_BG." (URL)</td>
<td 	colspan = 3><input type=text name=XLAY_BgURL size=" . KWL_FormSize(13) ." maxlength=96 value=\"" . $LAYOUT["BgURL"] . "\"></td>
</tr>

<tr>
<td>"._LAYOUT_LOGO." (URL)</td>
<td	colspan=3><input type=text name=XLAY_LogoURL size=" . KWL_FormSize(13) ." maxlength=96 value=\"" . $LAYOUT["LogoURL"] . "\"></td>
</tr>

<tr>
<td>"._LAYOUT_FONT."</td>
<td 	colspan=3><input type=text name=XLAY_FontFamily size=" . KWL_FormSize(13) ." maxlength=96 value=\"" . $LAYOUT["FontFamily"] . "\"></td>
</tr>

<tr>
<td>"._LAYOUT_WIDTH." (pixel / %)</td>
<td><input 	type=text  name=XLAY_PageWidth size=" . KWL_FormSize(5) ." maxlength=10 value=\"" . $LAYOUT["PageWidth"] . "\"></td>
<td>Area Padding</td>
<td><input 	type=text  name=XLAY_AreaPadding size=" . KWL_FormSize(5) ." maxlength=10 value=\"" . $LAYOUT["AreaPadding"] . "\"></td>
</tr>

<tr>
<td>BG Color</td>
<td><input 	type=text  name=XLAY_BgColor size=" . KWL_FormSize(7) ." maxlength=10 value=\"" . $LAYOUT["BgColor"] . "\"></td>
<td>FG Color</td>
<td><input 	type=text  name=XLAY_FgColor size=" . KWL_FormSize(7) ." maxlength=10 value=\"" . $LAYOUT["FgColor"] . "\"></td>
</tr>


<tr>
<td>Link Color</td>
<td><input 	type=text name=XLAY_LinkColor size=" . KWL_FormSize(7) ." maxlength=10 value=\"" . $LAYOUT["LinkColor"] . "\"></td>
<td>Hover Color</td>
<td><input 	type=text  name=XLAY_HoverColor size=" . KWL_FormSize(7) ." maxlength=10 value=\"" . $LAYOUT["HoverColor"] . "\"></td>
</tr>

<tr>
<td>Navigation Text</td>
<td><input 	type=text name=XLAY_NavColor size=" . KWL_FormSize(7) ." maxlength=10 value=\"" . $LAYOUT["NavColor"] . "\"></td>
<td>"._LAYOUT_TITLE_COLOR."</td>
<td><input 	type=text  name=XLAY_TitleColor size=" . KWL_FormSize(7) ." maxlength=10 value=\"" . $LAYOUT["TitleColor"] . "\"></td>
</tr>

<tr>
<td>"._LAYOUT_BLOCK_WIDTH." ("._BLOCK_LEFT.")</td>
<td><input 	type=text  name=XLAY_LeftBlocksWidth size=" . KWL_FormSize(7) ." maxlength=10 value=\"" . $LAYOUT["LeftBlocksWidth"] . "\"></td>
<td>"._LAYOUT_BLOCK_WIDTH." ("._BLOCK_RIGHT.")</td>
<td><input 	type=text  name=XLAY_RightBlocksWidth size=" . KWL_FormSize(7) ." maxlength=10 value=\"" . $LAYOUT["RightBlocksWidth"] . "\"></td>
</tr>

<tr>
<td>"._LAYOUT_BLOCK_ALIGN."</td>
<td>
<select	name	=XLAY_BlocksAlign>
	<option value=\"left\" " . ($LAYOUT["BlocksAlign"]=="left" ? "selected" : "") . ">"._BLOCK_LEFT."</option>
	<option value=\"right\" " . ($LAYOUT["BlocksAlign"]=="right" ? "selected" : "") . ">"._BLOCK_RIGHT."</option>
</select>
</td>
<td colspan=2>&nbsp;</td>
</tr>

<tr>
<td colspan=4><BR><h3>"._LAYOUT_THEME."</h3>
($dir)</td>
</tr>

<tr>
<td>Header</td>
<td>
<select	name	= XLAY_TMPL_Header>";
	$VAR["Content"] .= KWL_GetTmpl("header","TMPL_Header");

$VAR["Content"] .= "
</select>
</td>
<td>Footer</td>
<td>
<select	name	= XLAY_TMPL_Footer>";
	$VAR["Content"] .= KWL_GetTmpl("footer","TMPL_Footer");

$VAR["Content"] .= "
</select>
</td>
</tr>

<tr>
<td>"._LAYOUT_B_LEFT."</td>
<td>
<select	name	= XLAY_TMPL_LeftBlock>";
	$VAR["Content"] .= KWL_GetTmpl("block","TMPL_LeftBlock");

$VAR["Content"] .= "
</select>
</td>
<td>"._LAYOUT_B_RIGHT."</td>
<td>
<select	name	= XLAY_TMPL_RightBlock>";
	$VAR["Content"] .= KWL_GetTmpl("block","TMPL_RightBlock");

$VAR["Content"] .= "
</select>
</td>
</tr>


<tr>
<td>"._SUMMARY."</td>
<td>
<select	name	= XLAY_TMPL_Summary>";
	$VAR["Content"] .= KWL_GetTmpl("summary","TMPL_Summary");

$VAR["Content"] .= "
</select>
</td>
<td>"._STORY."</td>
<td>
<select	name	= XLAY_TMPL_Story>";
	$VAR["Content"] .= KWL_GetTmpl("story","TMPL_Story");

$VAR["Content"] .= "
</select>
</td>
</tr>

<tr>
<td>"._COMMENT."</td>
<td>
<select	name	= XLAY_TMPL_Comment>";
	$VAR["Content"] .= KWL_GetTmpl("comment","TMPL_Comment");

$VAR["Content"] .= "
</select>
</td>
<td>Main</td>
<td>
<select	name	= XLAY_TMPL_Main>";
	$VAR["Content"] .= KWL_GetTmpl("main","TMPL_Main");

$VAR["Content"] .= "
</select>
</td>
</tr>

</table>
</form>";

KWL_DrawMain($VAR);
include("../include/footer.inc.php");
?>
