<?
/*--------------------------------------------------------------------
   KorWeblog :: Highly Customizable Weblog/CMS
   Copyright (C) 2001-2004 by Im Eunjea <eunjea@kldp.org>
   For detail of license and/or other info, see the file doc/COPYING.
   http://weblog.kldp.org
----------------------------------------------------------------------

LICENSE

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
----------------------------------------------------------------------*/

include("../include/common.inc.php");
include("auth.inc.php");
include("../include/header.inc.php");

$rlink_table = "T_Random_Link";
if (empty($CONF['rlink_title'])) $CONF['rlink_title'] = _RANDOM_LINK;
settype($act, "string");   
if ($act == "add") {
   $url = KWL_UrlCheck($url);
   $title = trim($title);
   if ($url && $title) {
      SqlQuery("INSERT INTO $rlink_table (url,title) VALUES ('$url','$title')");
   }

} elseif ($act == "editok" && $id) {
   $url = KWL_UrlCheck($url);
   $title = trim($title);
   if ($url && $title) {
      SqlQuery("UPDATE $rlink_table SET url = '$url', title = '$title' WHERE id = $id");
   }

} elseif ($act == "nums" && $rlink_nums) {
   if (SqlCount("T_Config","Name","rlink_source")) {
      SqlQuery("UPDATE T_Config SET Value = $rlink_source WHERE Name = 'rlink_source'");
   } else {
      SqlQuery("INSERT INTO T_Config (Name,Value) VALUES ('rlink_source','$rlink_source')");
   }

   if (SqlCount("T_Config","Name","rlink_nums")) {
      SqlQuery("UPDATE T_Config SET Value = $rlink_nums WHERE Name = 'rlink_nums'");
   } else {
      SqlQuery("INSERT INTO T_Config (Name,Value) VALUES ('rlink_nums','$rlink_nums')");
   }
   $rlink_title = KWL_PrepareHtml($rlink_title);
   if (SqlCount("T_Config","Name","rlink_title")) {
      SqlQuery("UPDATE T_Config SET Value = '$rlink_title' WHERE Name = 'rlink_title'");
   } else {
      SqlQuery("INSERT INTO T_Config (Name,Value) VALUES ('rlink_title','$rlink_title')");
   }
   $CONF['rlink_nums'] = $rlink_nums;
   $CONF['rlink_title'] = $rlink_title;
   $CONF['rlink_source'] = $rlink_source;
} elseif ($act == "kill" && $id) {
   SqlQuery("DELETE FROM $rlink_table WHERE id = $id");   
}

$out = new KWL_Html;
$VAR['Content'] = $out->form_start("admin/random_link.php","rlink").
                $out->table_start("100%",'',0,0,3).
                "<tr><td>". _RANDOM_LINK_SOURCE .":</td><td>".
                $out->select("rlink_source",array ( 0 => _RLINK_PREF1,
                                                  1 => _RLINK_PREF2,
                                                  2 => _RLINK_PREF3 ),
                             $CONF['rlink_source']) .
                "</td></tr>".
                "<tr><td>". _RANDOM_LINK_NUMS .":</td><td>".
                $out->input_form("text","rlink_nums",$CONF['rlink_nums'],KWL_FormSize(2),5).
                "</td></tr>".
                "<tr><td>". _RANDOM_LINK_HEAD .":</td><td>".
                $out->input_form("text","rlink_title",$CONF['rlink_title'],KWL_FormSize(15),255).
                "</td></tr><tr><td colspan=2>".
                $out->input_form("hidden","act","nums").
                $out->input_form("submit",'',_SAVE_CHANGE).
                "</td></tr>". $out->table_end() . $out->form_end();
                
$VAR['Heading'] = _RANDOM_LINK;
KWL_DrawMain($VAR);

if ($act == "edit") {
   $rt = SqlQueryFetchArray("select * from $rlink_table where id = $id");
   $VAR['Content'] = rlink_form($out,$rt);
   $VAR['Heading'] = _RANDOM_LINK_EDIT;
} else {
   $VAR['Content'] = rlink_form($out);
   $VAR['Heading'] = _RANDOM_LINK_ADD;
}
KWL_DrawMain($VAR);

settype($by, "string");
if ($by=="id" || $by=="url" || $by=="title" || $by=="hits") {
   if ($sort=="asc") { $sort = "$by $sort"; $rsort = "desc"; }
   else if ($sort=="desc") { $sort = "$by $sort"; $rsort = "asc"; }
   else { $sort = "id asc"; $rsort = "desc"; }
} else { $sort = "id asc"; $rsort = "desc"; }

$rt = SqlQuery("SELECT * FROM $rlink_table ORDER BY $sort");

if (mysql_num_rows($rt)) {
   $VAR['Content'] = $out->table_start("100%",'',1,0,3).
                   "<tr><th><a href=\"". $_SERVER['PHP_SELF'] ."?by=id&sort=$rsort\">no.</a></th>".
                   "<th><a href=\"". $_SERVER['PHP_SELF'] ."?by=url&sort=$rsort\">Url</a></th>".
                   "<th><a href=\"". $_SERVER['PHP_SELF'] ."?by=title&sort=$rsort\">". _RANDOM_LINK_TITLE ."</a></th>".
                   "<th><a href=\"". $_SERVER['PHP_SELF'] ."?by=hits&sort=$rsort\">hits</a></th>".
                   "<th>op</th>";
   $no = 1;
   while ($A = mysql_fetch_array($rt)) {
      $VAR['Content'] .= "<tr><td>$no</td>".
                       "<td><a href=\"$A[url]\" target=\"_blank\">$A[url]</a></td>".
                       "<td>". KWL_PrepareHtml($A['title']) ."</td>".
                       "<td>". number_format($A['hits']) ."</td>".
                       "<td><A ONCLICK=\"return getconfirm();\" HREF=\"". $_SERVER['PHP_SELF'] ."?act=kill&id=$A[id]\"><IMG SRC=\"$CONF[img_url]/kill.gif\" ALT=\"kill\" BORDER=\"0\"></A>&nbsp;<A HREF=\"". $_SERVER['PHP_SELF'] ."?act=edit&id=$A[id]\"><IMG SRC=\"$CONF[img_url]/edit.gif\" ALT=\"edit\" BORDER=\"0\"></A></td></tr>";
      $no++;
   }
   $VAR['Content'] .= $out->table_end();
   $VAR['Heading'] = _RANDOM_LINK;
   KWL_DrawMain($VAR);
}
include("../include/footer.inc.php");

function rlink_form($out,$A='') {
   if (is_array($A)) $what = "editok";
   else {
      $what = "add";
      $A['url'] = $A['title'] = $A['id'] = "";
   }
   
   return $out->form_start("admin/random_link.php","rlink").
          $out->table_start("100%").
          "<tr><td>* Url:</td>".
          "<td>". $out->input_form("text","url",$A['url'],KWL_FormSize(20),255) ."</td></tr>".
          "<tr><td>* ". _RANDOM_LINK_TITLE .":</td>".
          "<td>". $out->input_form("text","title",KWL_PrepareHtml($A['title']),KWL_FormSize(20),255) ."</td></tr>".
          "<tr><td colspan=2>".
          $out->input_form("hidden","id",$A['id']).
          $out->input_form("hidden","act",$what).
          $out->input_form("submit",'',_SAVE_CHANGE).
          "</td></tr>". $out->table_end() . $out->form_end();
}
?>
