<?
/*--------------------------------------------------------------------
   KorWeblog :: Highly Customizable Weblog/CMS
   Copyright (C) 2001-2004 by Im Eunjea <eunjea@kldp.org>
   For detail of license and/or other info, see the file doc/COPYING.
   http://weblog.kldp.org
----------------------------------------------------------------------

LICENSE

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
----------------------------------------------------------------------*/

include("include/common.inc.php");

KWL_CheckLocalReferer(1);

$url = rawurldecode($url);
$img_type = KWL_filetype_check($url);

$img_size = getimagesize($url);
switch($img_size[2]) {
	case 1:
		$img = imagecreatefromgif($url);
		break;
	case 2:
		$img = imagecreatefromjpeg($url);
		break;
	case 3:
		$img = imagecreatefrompng($url);
		break;
}

$orig['width'] = imagesx($img);
$orig['height'] = imagesy($img);

$new['width'] = $CONF['thumb_size'];
$new['height'] = intval($orig['height']/($orig['width']/$new['width']));

$thumb = imagecreate($new['width'],$new['height']);
imagecopyresized($thumb,$img,0,0,0,0,$new['width'],$new['height'],$orig['width'],$orig['height']);

switch($img_type) {
	case "wbmp" :
		$type_header = "vnd.wap.wbmp";
	break;

	default :
		$img_type = ($ImgType == "jpg") ? "jpeg" : $img_type;
		$type_header = $img_type;
}
header("Content-type: image/$type_header");
switch($type) {
	case "png" :
		imagepng($thumb);
	break;
	case "wbmp" :
		imagewbmp($thumb);
	break;
	case "gif" :
		imagegif($thumb);
	default :
		imagejpeg($thumb,'',80);
}
imagedestroy($thumb);
?>
