<?
/*--------------------------------------------------------------------
   KorWeblog :: Highly Customizable Weblog/CMS
   Copyright (C) 2001-2004 by Im Eunjea <eunjea@kldp.org>
   For detail of license and/or other info, see the file doc/COPYING.
   http://weblog.kldp.org
----------------------------------------------------------------------

LICENSE

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
----------------------------------------------------------------------*/

if (!defined("LOAD_MODULE"))
   die ("You can not access this file directly...");

$out = new KWL_Html;

$VAR['Heading'] = "<a name=\"comments\">"._POSTCOMMENT."</a>";
$VAR['Content'] = $out->form_start("submit.php","Com") .
                $out->table_start("100%",'',0,0,3);

if ($CONF['NoLogin_User']) {
   $u = KWL_GetCookieUser();
   
   $VAR['Content'] .= "<tr><td>* ". _NAME .":</td>".
                    "<td>". $out->input_form("text","Author",$u[0],$size['name'],32) ."</td></tr>\n".
                    "<tr><td>* ". _EMAIL .":</td>".
                    "<td>". $out->input_form("text","AuthorEmail",$u[1],$size['name'],96) ."</td></tr>\n".
                    "<tr><td>". _URL .":</td>".
                    "<td>". $out->input_form("text","AuthorURL",$u[2],$size['name'],96) ."</td></tr>\n";

	if ($CONF['ENABLE_FACE']) {
		$VAR['Content'] .= "<tr><td>". _FACE .": </td><td>". $out->input_form("text","faceicon",'',KWL_FormSize(5),128) ." <font size=\"-1\">(<a href=\"$CONF[G_URL]/viewimg.php?path=images.d/face&amp;form=Com&amp;var=faceicon\" target=\"_new\" onClick=\"new_windows('$CONF[G_URL]/viewimg.php?path=images.d/face&amp;form=Com&amp;var=faceicon','viewicon',1,1,350,380); return false\">"._VIEW_FACE."</a>)</font></td></tr>\n";
	}
	if ($CONF['ENABLE_CEDIT']) {
		$VAR['Content'] .= "<tr><td>". _PASSWD ."</td><td>". $out->input_form("password","passwd",'',KWL_FormSize(7),13) ."<br><font size=\"-1\">* ". _PASS_DESC ."</font></td></tr>\n";
	}
	if ($CONF['AllowAnon']) {
      $VAR['Content'] .= "<tr><td>". _ANONYMOUS ."</td><td>". $out->check_box("anon") ."</td></tr>\n";
   }

} else {
	
   if ($login) {
	   $VAR['Content'] .= "<tr><td>". _NAME .":</td>" .
                       "<td><a href=\"$CONF[G_URL]/user.php\">". KWL_PrepareHtml($user['name']) ."</A> (#$user[uid])</td>\n";
		if ($CONF['AllowAnon'])
			$VAR['Content'] .= "<tr><td>". _ANONYMOUS .": </td> "
			                . "<td>". $out->check_box("anon") ."</td></tr>";
		if ($CONF['EmailReply']) {
			$VAR['Content'] .= "<tr><td>". _MAILCOMMENTS .": </td>"
			                . "<td>". $out->check_box("ereply",1) ."</td></tr>";
		}
		if ($fix && $CONF['AllowScore'] && $CONF['SCORING']) {
			$VAR['Content'] .= "<tr><td>" . _U_SCORE . ":</td>"
				. "<td><SELECT NAME=\"uscore\">";
			if ($oscore != -1) 
				$VAR['Content'] .= "<option value=\"minus\">-1</option>";
			$VAR['Content'] .= "<option value=\"0\" selected>" . _U_SCORE1 . "</option>";
			if ($oscore != 1)
				$VAR['Content'] .= "<option value=\"plus\">+1</option>";
			$VAR['Content'] .= "</select></td>";
		}
	} else {
		$VAR['Content'] .= "<td colspan=\"2\">";
      $location = urlencode($_SERVER['PHP_SELF'] ."?". $_SERVER['QUERY_STRING']);
		if ($CONF['AllowAnon']) {
			$VAR['Content'] .= $out->input_form("HIDDEN","anon","on") .
            sprintf(_NEED_LOGIN,
                  "<a href=\"$CONF[G_URL]/login.php?location=$location#login\">"._LOGIN."</a>",
                  "<a href=\"$CONF[G_URL]/login.php\">"._UREGITER."</a>") . "</td></tr>\n";
		} else {
			$VAR['Content'] .= sprintf(_NO_POST,
               "<a href=\"$CONF[G_URL]/login.php?location=$location#login\">"._LOGIN."</a>",
               "<a href=\"$CONF[G_URL]/login.php\">"._UREGITER."</a>") . 
               "</td></tr>". $out->table_end() . $out->form_end();
			KWL_DrawMain($VAR);
			return;
		}
	}
	if ($CONF['ENABLE_FACE']) {
		$VAR['Content'] .= "<tr><td>". _FACE .": </td><td>". $out->input_form("text","faceicon",'',KWL_FormSize(5),128) ." <font size=\"-1\">(<a href=\"$CONF[G_URL]/viewimg.php?path=images.d/face&amp;form=Com&amp;var=faceicon\" target=\"_new\" onClick=\"new_windows('$CONF[G_URL]/viewimg.php?path=images.d/face&amp;form=Com&amp;var=faceicon','viewicon',1,1,350,380); return false\">"._VIEW_FACE."</a>)</font></td></tr>\n";
	}
	if ($CONF['ENABLE_CEDIT'] && !$login) {
		$VAR['Content'] .= "<tr><td>". _PASSWD ."</td><td>". $out->input_form("password","passwd",'',KWL_FormSize(7),13) ."</td></tr><tr><td colspan=\"2\">* ". _PASS_DESC ."</td></tr>\n";
	}
}

$VAR['Content'] .= "<tr><td colspan=\"2\">". _COMMENT .": ". 
                 KWL_FormResizer("Com.Content",$size['text'],10) ."<br />".
                 $out->textarea("Content",10,$size['text']) .
                 "<br />". KWL_MakeSelectParse($CONF['reply_parse'],$CONF['Reply_PLevel']) .
                 "</td></tr><tr><td colspan=\"2\">";

if ($CONF['ENABLE_QUOTE'] && basename($_SERVER['PHP_SELF'])=="write.php") {
   $VAR['Content'] .= $out->input_form("HIDDEN","hide",$otxt) . "<input tabindex=\"100\" type=\"Button\" name=\"quote\" value=\""._QUOTE."\" onClick=\"this.form.Content.value=this.form.Content.value + this.form.hide.value; this.form.hide.value ='';\">&nbsp;\n";
}

$VAR['Content'] .= $out->input_form("hidden","what","comment") .
                 $out->input_form("hidden","ParentRid",$parentrid) .
                 $out->input_form("hidden","TopRid",$toprid) .
                 $out->input_form("hidden","where",$where) .
                 $out->input_form("hidden","hcode",KWL_HcodeMake($parentrid.$toprid)) .
                 $out->input_form("submit","mode",_PREVIEW) .
                 ($CONF['reply_parse'] ? _MUST_PREVIEW : "") .
                 ($CONF['reply_parse'] ? "" : $out->input_form("SUBMIT","mode",_SUBMIT));
$VAR['Content'] .= "</td></tr>". $out->table_end() . $out->form_end();
KWL_DrawMain($VAR);
?>
