<?
/*--------------------------------------------------------------------
   KorWeblog :: Highly Customizable Weblog/CMS
   Copyright (C) 2001-2004 by Im Eunjea <eunjea@kldp.org>
   For detail of license and/or other info, see the file doc/COPYING.
   http://weblog.kldp.org
----------------------------------------------------------------------

LICENSE

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
----------------------------------------------------------------------*/

if (!defined("LOAD_MODULE"))
   die ("You can not access this file directly...");

if ($CONF['CHECK_TIME']) {
   $process_time = new KWL_Process_Time;
   $process_time->timer("start");
}

echo "<?xml version=\"1.0\" encoding=\"$rdf_lang\"?>
<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\"
    \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">
<html xmlns=\"http://www.w3.org/1999/xhtml\">
<head>
<meta http-equiv=\"Content-Type\" content=\"text/html; charset=$rdf_lang\" />\n";
if ($CONF['admin_login'] || basename($_SERVER['PHP_SELF']) == "moderate.php") {
	echo "<meta http-equiv=\"pragma\" content=\"no-cache\" />
<script language=\"javascript\">
<!--
function getconfirm() {
	if(confirm(\"". _AUSURE ."\")) {
		return true;
	} else {
		return false;
	}
}
//-->
</script>\n";
}
$meta_keys = KWL_ReadFile("$CONF[G_PATH]/logs/meta.txt");

list($site_name,$site_desc) = KWL_PrepareHtml($CONF['SiteName'],$CONF['SiteSlogan']);
$site_title = "$site_name - $site_desc";
if (!empty($head)) 
	$site_title .= " :: " . KWL_PrepareHtml($head);
if (!empty($meta_keys)) 
	echo "<meta name=\"keywords\" content=\"". KWL_PrepareHtml(trim($meta_keys)) ."\" />\n";
echo "<meta name=\"author\" content=\"$site_name\" />
<meta name=\"copyright\" content=\"copyright (c) ". date("Y",time()) ." by $site_name\" />
<meta name=\"description\" content=\"$site_desc\" />
<meta name=\"generator\" content=\"KorWeblog $G_VER - http://weblog.kldp.org\" />
<link rel=\"alternate\" type=\"application/rss+xml\" title=\"RSS\" href=\"{$CONF['G_URL']}/rss.php\" />
<link rel=\"start\" href=\"{$CONF['G_URL']}\" title=\"". htmlspecialchars(_INDEX) ."\" />
<title>$site_title</title>
<style type=\"text/css\">
/*<![CDATA[*/
<!--\n".
"body, table, td { font-family: $LAYOUT[FontFamily]; }\n".
"A:hover {text-decoration: none; color: $LAYOUT[HoverColor]; }\n".
"A.nav {color: $LAYOUT[NavColor]; }\n".
"A.title {color: $LAYOUT[TitleColor]; }\n".
"-->
/*]]>*/
</style>\n";

if (file_exists("{$CONF['G_PATH']}/backend/template/$site_theme/theme.css")) {
   echo "<link rel=\"stylesheet\" type=\"text/css\" media=\"screen\" ".
      "href=\"{$CONF['G_URL']}/backend/template/$site_theme/theme.css"."\" />\n";
}

?>
<script language="JavaScript" type="text/javascript">
//<![CDATA[
<!-- Begin
  var child = null;
  var count = 0;
  function new_windows(addr,tag,scroll,resize,wid,hei) {
    var childname = 'KorWeblog' + count++;
    if(child != null) {
      if(!child.closed) { child.close(); }
    }
    child = window.open(addr,tag,'left=0, top=0, toolbar=0,scrollbars=' + scroll + ',status=0,menubar=0,resizable=' + resize + ',width=' + wid + ',height=' + hei +'');
    child.focus();
    return;
  }
//-->
//]]>
</script>
</head>

<body text="<? echo $LAYOUT["FgColor"] ?>" bgcolor="<? echo $LAYOUT["BgColor"] ?>" <? if (!empty($LAYOUT["BgURL"])) echo "background=\"$LAYOUT[BgURL]\""; ?> link="<? echo $LAYOUT["LinkColor"] ?>" vlink="<? echo $LAYOUT["LinkColor"]; ?>" alink="<? echo $LAYOUT["LinkColor"]; ?>">

<?
if (basename($_SERVER['PHP_SELF'])=="download.php") KWL_MouseOverInit();
KWL_Header();
?>

<table border="0" cellspacing="0" cellpadding="0" width="<?=$LAYOUT['PageWidth']?>" align="center">
<tr>
   <td colspan="5" align="center"><img src="<?=$CONF['G_URL']?>/images.d/speck.gif" width="1" height="<?=$LAYOUT['AreaPadding']?>" alt="" /></td>
</tr>
<tr>

<? KWL_doBlocks("l") ?>

<td width="100%" valign="top">

<? if (!empty($msg)) KWL_Notice($msg) ?>
