<?
/*--------------------------------------------------------------------
   KorWeblog :: Highly Customizable Weblog/CMS
   Copyright (C) 2001-2004 by Im Eunjea <eunjea@kldp.org>
   For detail of license and/or other info, see the file doc/COPYING.
   http://weblog.kldp.org
----------------------------------------------------------------------

LICENSE

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
----------------------------------------------------------------------*/

if (!defined("LOAD_MODULE"))
   die ("You can not access this file directly...");
include("$CONF[G_PATH]/include/kmod/download/lang/$LANG". ".php");
include("$CONF[G_PATH]/include/javabox.inc.php");

function verification_file() {
	$CONF = KWL_GetConf();

	$sql  = "SELECT * FROM T_Download WHERE Verified = 0 ORDER BY date";
	$result = SqlQuery($sql);

	if (!mysql_num_rows($result)) return _NO_UNVERIFIED;
	$content = "
<table border=\"0\" cellspacing=\"0\" cellpadding=\"2\" width=\"100%\">
<tr>
	<td align=\"center\">
	<b>"._FILE_NAME."</b></td>
	<td align=\"center\"><b>"._FILE_SIZE."</b></td>
	<td align=\"center\"><b>"._FILE_CATEGORY."</b></td>
	<td align=\"center\"><b>"._DATE."</b></td>
	<td align=\"center\" width=\"10\"><b>"._FILE_INFO."</b></td>
	<td align=\"center\" width=\"10\"><b>act</b></td>
</TR>
";
	$descimg = "<img src=\"$CONF[G_URL]/images.d/download/info.gif\" alt=\"info\" border=\"0\" />";

	while($A = mysql_fetch_array($result)) {
		$file = KWL_icon_check($A['filename']) . " $A[filename]";
		if (eregi("^(http|ftp|https)",$A['path'])) $size = "&nbsp;";
		else $size = KWL_FileHSize($A['filesize']);
		
		$content .= "<td><a href=\"download.php?mode=download&id=$A[id]\">$file</a></td>\n";
		$content .= "<td align=\"right\">$size</td>";
		$content .= "<td align=\"center\">";
		$content .= get_category($A['category']) . "</td>";
		$content .= "<td align=\"center\">";
		$content .= date("Y-m-d",$A['date']) . "</td>";
		$content .= "<td align=\"center\"><a href=\"download.php?mode=viewinfo&id=$A[id]\">$descimg</a></td>";
		$content .= "<td align=\"center\">";
		$content .= "<a onclick=\"return getconfirm();\" href=\"download.php?mode=killfile&id=$A[id]\"><img src=\"$CONF[img_url]/kill.gif\" border=\"0\" /></a> ";
		$content .= "<a href=\"download.php?mode=edit&amp;id=$A[id]\"><img src=\"$CONF[img_url]/edit.gif\" border=\"0\" /></a> ";
		$content .= "<a href=\"download.php?mode=verified&id=$A[id]\"><img src=\"$CONF[img_url]/verify.gif\" border=\"0\" /></a>";
		$content .= "</td></tr>\n<tr>";
	}
	$content .= "</tr></table>";
	return $content;
}

function get_category($id) {
	$ret = SqlResult("SELECT title FROM T_FileCategories WHERE id = $id");
	return htmlspecialchars($ret);	
}


function get_file_info($id) {
	$ret = SqlQueryFetchArray("SELECT * FROM T_Download WHERE id = $id");
	if (!is_array($ret)) die(_FILE_NOT);
	return $ret;
}

function download_file($id) {
	$CONF = KWL_GetConf();
	if ($CONF['deny_direct_dn']) KWL_CheckLocalReferer(1);
	$A = get_file_info($id);
	if (is_array($A)) {
		if (eregi("^(http|ftp|https)",$A['path'])) $url = $A['path'];
		elseif (file_exists("$CONF[G_PATH]/$CONF[dn_path]/$A[category]/$A[path]/$A[filename]")) {
            $url = "$CONF[G_URL]/$CONF[dn_path]/$A[category]/$A[path]/$A[filename]";
      } else die(_FILE_NOT);
      SqlQuery("UPDATE T_Download set hit = hit + 1 WHERE id = $id");
		header("Location: $url");
	} else die(_SQL_ERROR);
}

function kill_file($id) {
	$CONF = KWL_GetConf();
	$A = get_file_info($id);
	if (is_array($A)) {
		SqlQuery("DELETE FROM T_Download WHERE id = '$id'");
		@unlink("$CONF[G_PATH]/$CONF[dn_path]/$A[category]/$A[path]/$A[filename]");
		@rmdir("$CONF[G_PATH]/$CONF[dn_path]/$A[category]/$A[path]");
	}
}

function view_file_info ($id) {
	$CONF = KWL_GetConf();

	$A = get_file_info($id);
	$file = KWL_icon_check($A['filename']) . " $A[filename]";
	if (!$A['Verified']) $tmp = $file;
	else $tmp = "<a href=\"download.php?mode=download&amp;id=$A[id]\">$file</a>";
	if (empty($A['uname'])) $A['uname'] = _ANONY;
	$content = "
<table border=\"0\" cellspacing=\"0\" cellpadding=\"4\" width=\"100%\">
<tr>
	<td><b>"._FILE_NAME.":</b></td>
	<td>$tmp</a></td>
<tr>
	<td><b>"._FILE_SIZE.":</b></td>
	<td>". ($A['filesize'] ? KWL_FileHSize($A['filesize']) : "&nbsp;") ."</td>
<tr>
	<td><b>"._DATE.":</b></td>
	<td>".date("Y-m-d h:i a",$A['date'])."</td>
<tr>
	<td><b>"._FILE_HITS.":</b></td>
	<td>". number_format($A['hit']) ."</td>
<tr>
	<td><b>"._FILE_CATEGORY.":</b></td>
	<td>".htmlspecialchars(get_category($A['category']))."</td>
<tr>
	<td><b>"._FILE_BY_WHO.":</b></td>
	<td>$A[uname]</td>
<tr>
	<td valign=\"top\"><b>"._FILE_DESC.":</b></td>
	<td>". KWL_ParseContent($A['description'],$CONF["ParseLevel"]) ."</td>
<tr>
	<td><b>"._FILE_URL.":</b></td>
	<td><a class=\"clink\" href=\"$A[url]\" target=\"_blank\">$A[url]</a></td>
<tr>
	<td colspan=\"2\" align=\"center\">[
";
if ($CONF['dn_uedit'])
	$content .= "<a href=\"download.php?mode=edit&amp;id=$id\">"._EDIT."</a> | ";

$content .= "<a href=\"javascript:history.back()\" onmouseover=\"window.status='[Back]' ; return true\">Back</a> ]
	</td>
</tr></table>
";
return $content;
}

# īװ ֱ
function show_category($categories=0) {
	$CONF = KWL_GetConf();
	
	$content = "
<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\">
<tr>
	<td>
";
	$tmp = "(" . SqlCount("T_Download") . ")";
	if (!$categories) {
		$dirimg = "<img src=\"images.d/download/folder_open.gif\" alt=\"". _ALL_CATEGORY ."\" border=\"0\" />";
		$content .= "$dirimg <b>". _ALL_CATEGORY ."</b> $tmp</td>";
	} else {
		$dirimg = "<img src=\"images.d/download/folder.gif\" alt=\"". _ALL_CATEGORY ."\" border=\"0\" />";
		$content .= "$dirimg <a href=\"download.php\">"._ALL_CATEGORY."</a> $tmp</td>";
	}
	$sql = "SELECT * FROM T_FileCategories";
	if ($CONF['dn_csort']) $sql .= " ORDER BY title $CONF[dn_csort]";
	$result = SqlQuery($sql);

	$i=1;
	while($A = mysql_fetch_array($result)) {
		$content .= "<td>";
		$fnum = "(" . SqlCount("T_Download","category",$A['id']) . ")";
		if ($categories == $A['id']) {
			$dirimg = "<img src=\"images.d/download/folder_open.gif\" alt=\"$A[title]\" border=\"0\" />";
			$content .= "$dirimg <b>$A[title]</b>";
		} else {
			$dirimg = "<img src=\"images.d/download/folder.gif\" alt=\"$A[title]\" border=\"0\" />";
			$content .= "$dirimg <a href=\"download.php?categories=$A[id]\">";
			$content .= $A['title'] . "</a>";
		}
		$content .= " $fnum </td>\n";
		$i++;
		if ($i>($CONF['dn_pline'] - 1)) { $content .= "</tr><tr>\n"; $i=0; }
	}
	$content .= "</tr></table>\n";
	@mysql_free_result($result);
	
	if ($categories) {
		$desc = SqlResult("select description from T_FileCategories where id = $categories");
		if (!empty($desc)) $content .= "<hr /><table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\"><tr><td>$desc</td></tr></table>\n";
	}
	return $content;
}

#  ֱ
function show_files($sort,$categories,$page) {
	$CONF = KWL_GetConf();

$href = "download.php?categories=$categories";
$dimg = "<img src=\"images.d/download/down.gif\" alt=\"Sort Ascending\" border=\"0\" />";
$uimg = "<img src=\"images.d/download/up.gif\" alt=\"Sort Descending\" border=\"0\" />";
$descimg = "<img src=\"images.d/download/info.gif\" alt=\"info\" border=\"0\" />";
$content = "
<hr />
<table border=\"0\" cellspacing=\"0\" cellpadding=\"2\" width=\"100%\">
<tr>
	<td align=\"center\">
	<b><a href=\"$href&sort=filenamea\">$dimg</a>&nbsp;<a href=\"$href&sort=filenamea\">"._FILE_NAME."</a>&nbsp;<a href=\"$href&sort=filenamed\">$uimg</a></b></td>
	<td align=\"center\"><b><a href=\"$href&sort=filesize\">$dimg</a>&nbsp;<a href=\"$href&sort=filesized\">"._FILE_SIZE."</a>&nbsp;<a href=\"$href&sort=filesized\">$uimg</a></b></td>
	<td align=\"center\"><b><a href=\"$href&sort=category\">$dimg</a>&nbsp;<a href=\"$href&sort=category\">"._FILE_CATEGORY."</a>&nbsp;<a href=\"$href&sort=categoryd\">$uimg</a></b></td>
	<td align=\"center\"><b><a href=\"$href&sort=date\">$dimg</a>&nbsp;<a href=\"$href&sort=dated\">"._DATE."</a>&nbsp;<a href=\"$href&sort=dated\">$uimg</a></b></td>
	<td align=\"center\"><b><a href=\"$href&sort=hit\">$dimg</a>&nbsp;<a href=\"$href&sort=hitd\">"._FILE_HITS."</a>&nbsp;<a href=\"$href&sort=hitd\">$uimg</a></b></td>
	<td align=\"center\"><b>"._FILE_INFO."</b></td>
</tr>
";

switch ($sort) {
	case "filenamea":
		$qsort = "filename ASC";
		break;
	case "filenamed":
		$qsort = "filename DESC";
		break;
	case "filesize":
		$qsort = "filesize ASC";
		break;
	case "filesized":
		$qsort = "filesize DESC";
		break;
	case "category":
		$qsort = "category ASC";
		break;
	case "categoryd":
		$qsort = "category DESC";
		break;
	case "date":
		$qsort = "date ASC";
		break;
	case "dated":
		$qsort = "date DESC";
		break;
	case "hit":
		$qsort = "hit ASC";
		break;
	case "hitd":
		$qsort = "hit DESC";
		break;
	default:
		$qsort = "date DESC";
}

if (empty($page)) $page = 1;
$prev_page = $page - 1;
$next_page = $page + 1;
$page_start = ($CONF['dn_plimit'] * $page) - $CONF['dn_plimit'];

$sql  = "SELECT * FROM T_Download";
if ($categories) $sql .= " WHERE category = '$categories'";
$sql .= " ORDER BY $qsort";
$sql .= " LIMIT $page_start,$CONF[dn_plimit]";
$result = SqlQuery($sql);

while($A = mysql_fetch_array($result)) {
	$file = KWL_icon_check($A['filename']) . " $A[filename]";
	if (eregi("^(http|ftp|https)",$A['path'])) $size = "&nbsp;";
	else $size = KWL_FileHSize($A['filesize']);
	unset($box_text);
	if (!empty($A['description'])) {
		$box_text = _FILE_DESC . ":\n" . KWL_genSummary($A['description']);
		$box_text = KWL_MouseOverBox($box_text);
	} else $box_text = "";
	$content .= "<tr><td>";

	if (!$A['Verified']) $content .= $file . " (". _FILE_NO_VERF .")";
	else $content .= "<a href=\"download.php?mode=download&id=$A[id]\" $box_text>$file</a>";

	$content .= "</td>\n<td align=\"right\">"
		. "$size </td>"
		. "<td align=\"center\">"
		. get_category($A['category']) . "</td>"
		. "<td align=\"center\">"
		. date("Y-m-d",$A['date']) . "</td>"
		. "<td align=\"center\">". number_format($A['hit']) ."</td>"
		. "<td align=\"center\"><a href=\"download.php?mode=viewinfo&id=$A[id]\">$descimg</a>";
		
	if ($CONF['admin_login']) {
		$content .= "&nbsp;<a onclick=\"return getconfirm();\" href=\"download.php?mode=killfile&id=$A[id]\"><img src=\"$CONF[img_url]/kill.gif\" border=\"0\" /></a>&nbsp;<a href=\"download.php?mode=edit&id=$A[id]\"><img src=\"$CONF[img_url]/edit.gif\" border=\"0\" /></a>";
	}
	$content .= "</td>";
}

if (!$categories) $files_num = SqlCount("T_Download");
else $files_num = SqlCount("T_Download","category",$categories);

if (empty($page)) $page = 1;
$page_start = ($CONF['dn_plimit'] * $page) - $CONF['dn_plimit'];

$blah = KWL_npLink($files_num,$page,"$CONF[G_URL]/download.php?page=$prev_page&categories=$categories&sort=$sort",$CONF['dn_plimit']);

$content .= "<tr><td colspan=\"6\" align=\"center\"><hr>$blah</td>\n";
   if ($CONF['dn_mode'] || $CONF['admin_login']) {
      $content .= "<tr><td colspan=\"6\" align=\"right\">[ <a href=\"$CONF[G_URL]/download.php?mode=upload&amp;categories=$categories\">". _UPLOAD ."</a>".
                  " | <a href=\"$CONF[G_URL]/download.php?mode=uplink&amp;categories=$categories\">". _UPLINK ."</a> ]";
}

$content .= "</td></tr></table>\n";
@mysql_free_result($result);

return $content;
}

function upload_form($categories,$link=0) {
   global $user;
	$CONF = KWL_GetConf();

   $out = new KWL_Html;

   $content = $out->form_start("download.php","Upload",1).
              $out->table_start("100%",'',0,0,3).
"<tr>
   <td>"._FILE_CATEGORY.":</td>
   <td>
	<select name=\"category\">";
$result = SqlQuery("SELECT * FROM T_FileCategories ORDER BY id ASC");
while($A = mysql_fetch_array($result)) {
	$foo = $categories == $A['id'] ? "selected" : "";
	$content .= sprintf ("<option value=\"$A[id]\" %s>$A[title]</option>\n",$foo);
}
$content .= "</select></td></tr>";

if ($link) {
   $content .= "
<tr>
	<td>". _PROGRAM_NAME .":</td>
	<td>". $out->input_form("text","filename",'',KWL_FormSize(10),256) ."
	</td>
</tr>
<tr>
	<td>". _FILE ." URL:</td>
	<td>". $out->input_form("text","filelink",'',KWL_FormSize(15),256) ."
	</td>
</tr>";
   
} else {
   $content .= "
<tr>
	<td>". _FILE .":</td>
	<td>". $out->input_form("HIDDEN","max_file_size",$CONF['dn_maxsize']).
          $out->input_form("file","userfile",'',KWL_FormSize(15),256) ."<br />
          (". _MAX_FILE_SIZE . " " . KWL_FileHSize($CONF['dn_maxsize']). ")
	</td>
</tr>";
}

$content .= "
<tr>
	<td>". _FILE_URL .":</td>
	<td>". $out->input_form("text","url",'',KWL_FormSize(15),255) ."
	</td>
</tr>
<tr>
   <td>". _FILE_DESC .":</td>
	<td>". $out->textarea("description",5,KWL_FormSize(20)) ."
	</td>
</tr>";
if (!is_array($user)) {
   $content .= "
<tr>
	<td>". _NAME .":</td>
	<td>". $out->input_form("text","uname",'',KWL_FormSize(10),30) ."
	</td>
</tr>
<tr>
	<td>". _PASSWD .":</td>
	<td>". $out->input_form("password","passwd",'',KWL_FormSize(7),13) ."
	(". _PASS_INFO .")
	</td>
</tr>";
}

if ($link) { 
   $mode = "filelink";
   $button = _UPLINK;
} else { 
   $mode = "fileup";
   $button = _UPLOAD;
}

$content .= "
<tr>
	<td colspan=\"2\">". $out->input_form("hidden","mode",$mode).
                    $out->input_form("submit",'',$button)."
	</td>
</tr>". $out->table_end() . $out->form_end();
return $content;
}

function edit_file($id) {

	$A = get_file_info($id);
	
		$content = "
<form action=\"". KWL_GetConf("G_URL") ."/download.php\" name=\"Update\" method=\"POST\" enctype=\"multipart/form-data\">
<table border=\"0\" cellspacing=\"0\" cellpadding=\"5\" width=\"100%\">
<tr>
	<td>"._FILE_NAME.":</td>
	<td>". KWL_icon_check($A['filename']) . " " . $A['filename'] . 
   ($A['filesize'] ? " - ". KWL_FileHSize($A['filesize'],1) : "") ."</td>
<tr>
	<td>"._FILE_CATEGORY.":</td>
	<td>
	<select name=\"category\">";
$result = SqlQuery("SELECT * FROM T_FileCategories ORDER BY id ASC");
while($B = mysql_fetch_array($result)) {
	$foo = ($A['category'] == $B['id']) ? "selected" : "";
	$content .= sprintf ("<option value=\"$B[id]\" %s>$B[title]</option>\n",$foo);
}

$content .= "</select>
	</td>
<tr>
	<td>"._FILE_URL.":</td>
	<td>
	<input type=\"text\" name=\"url\" value=\"$A[url]\" size=".KWL_FormSize(15)." maxlength=\"255\">
	</td>
<tr>
   <td>"._FILE_DESC.":</td>
	<td>
	<textarea name=\"description\" ".KWL_Form_Wrap()." rows=\"5\" cols=" . KWL_FormSize(20) . ">".htmlspecialchars($A['description'])."</textarea>
	</td>
<tr>
	<td>"._NAME.":</td>
	<td>
	<input type=\"text\" name=\"uname\" value=\"$A[uname]\" size=\"" . KWL_FormSize(10) . "\" maxlength=\"30\">
	</td>
<tr>
	<td>"._PASSWD.":</td>
	<td>
	<input type=\"password\" name=\"passwd\" size=\"" . KWL_FormSize(7) . "\" maxlength=\"13\">
	</td>
<tr>
	<td colspan=\"2\">
	<input type=\"hidden\" name=\"filename\" value=\"$A[filename]\">
	<input type=\"hidden\" name=\"oldfilepath\" value=\"$A[path]\">
	<input type=\"hidden\" name=\"id\" value=\"$A[id]\">
	<input type=\"hidden\" name=\"oldc\" value=\"$A[category]\">
	<input type=\"hidden\" name=\"mode\" value=\"updatefile\">
	<input type=\"hidden\" name=\"hcode\" value=\"". KWL_HcodeMake($A['filename'].$A['path'].$A['id'].$A['category']."updatefile") ."\">
	<input type=\"submit\" value=\""._EDIT."\"> &nbsp;"
	. _DELETE_FILE ." <input type=\"checkbox\" name=\"deletefile\"> 
	</td>
</tr></table>
</form>
";
return $content;
}

function check_fpasswd($id,$passwd) {
	$CONF = KWL_GetConf();
	$orig_pass = SqlResult("SELECT passwd FROM T_Download WHERE id = '$id'");
	if (md5($passwd)==$CONF["Passwd"]) return 1;
	elseif ($CONF['admin_login']) return 1;
	elseif (!empty($passwd) && !empty($orig_pass)) {
		if (crypt($passwd, $orig_pass)==$orig_pass) return 1;
	}
}
?>
