<?
/*--------------------------------------------------------------------
   KorWeblog :: Highly Customizable Weblog/CMS
   Copyright (C) 2001-2004 by Im Eunjea <eunjea@kldp.org>
   For detail of license and/or other info, see the file doc/COPYING.
   http://weblog.kldp.org
----------------------------------------------------------------------

LICENSE

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
----------------------------------------------------------------------*/

if (!defined("LOAD_MODULE"))
   die ("You can not access this file directly...");
include("$CONF[G_PATH]/include/kmod/stats/lang/$LANG". ".php");
include_once("$CONF[G_PATH]/include/kmod/stats/function.inc.php");

$head = _SITESTATS;
include("$CONF[G_PATH]/include/header.inc.php");

$out = new KWL_Html;
$VAR['Content'] = $out->table_start("100%",'',0,0,2);

if (count($TOPIC) > 1) {
   $VAR['Content'] .= "<tr><td>". _TOTALTOPIC .":</td>".
                    "<td align=\"right\">". count($TOPIC) ."</td></tr>\n";
}

$VAR['Content'] .= "<tr><td>". _TOTALSTORIES .":</td>".
                 "<td align=\"right\">". number_format($TOTAL_STORY) ."</td></tr>\n";

if ($CONF['Moderation'] == "1" || $CONF['Moderation'] == "2") {
   $story_wating = SqlCount("T_Stories","Verified","N");
   $VAR['Content'] .= "<tr><td>". _WATING_STORY .":</td>".
                    "<td align=\"right\">$story_wating</td></tr>\n";
}
                 
$avg_hit = SqlResult("SELECT floor(avg(Hits)) FROM T_Stories WHERE Verified = 'Y'");
$VAR['Content'] .= "<tr><td>". _AVGHITS .":</td>".
                 "<td align=\"right\">". number_format($avg_hit) . "</td></tr>\n";

$total_reply = SqlCount("T_Comments");
if ($CONF["Comments"]) {
   $VAR['Content'] .= "<tr><td>". _TOTALCOMMENTS .":</td>".
                    "<td align=\"right\">". number_format($total_reply) ."</td></tr>\n";
   if ($total_reply > $TOTAL_STORY) {
      $VAR['Content'] .= "<tr><td>". _AVACOMMENTS .":</td>".
                       "<td align=\"right\">". intval($total_reply / $TOTAL_STORY) ."</td></tr>\n";
   }
}
$tmp = SqlCount("T_PollQuestions");
if ($tmp) $VAR['Content'] .= "<tr><td>". _TOTALPOLLS .":</td><td align=\"right\">". $tmp ."</td></tr>\n";

$tmp = SqlCount("T_Links");
if ($tmp) $VAR['Content'] .= "<tr><td>". _TOTALLINKS .":</td><td align=\"right\">". $tmp ."</td></tr>\n";

$tmp = SqlCount("T_Users");
if ($tmp) $VAR['Content'] .= "<tr><td>". _TOTAL_USER .":</td><td align=\"right\">". $tmp ."</td></tr>\n";

$VAR['Content'] .= "<tr><td>KorWeblog Version:</td><td align=\"right\">$G_VER</td></tr>" . $out->table_end();
$VAR['Heading'] = _SITESTATS;
KWL_DrawMain($VAR);

$stats = new KWL_STATS;
$stats->top_story($out);
$stats->hot_story($out);
$stats->top_poll($out);
$stats->top_page($out);

if ($CONF['Links']) $stats->top_link($out);
if (SqlCount("T_Blocks","URL","rlink.php","Type","3"))
   $stats->random_link($out);
if (SqlCount("T_Blocks","URL","rbutton.php","Type","3"))
   $stats->random_button($out);
if ($CONF['Time_Counter']) $stats->stats_time($out);
if ($CONF['Counter']) $stats->counter_stats($out);

include("$CONF[G_PATH]/include/footer.inc.php");
?>
