<?
/*--------------------------------------------------------------------
   KorWeblog :: Highly Customizable Weblog/CMS
   Copyright (C) 2001-2004 by Im Eunjea <eunjea@kldp.org>
   For detail of license and/or other info, see the file doc/COPYING.
   http://weblog.kldp.org
----------------------------------------------------------------------

LICENSE

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
----------------------------------------------------------------------*/

include("include/common.inc.php");

if (!$CONF['trackping']) KWL_ShowError(_SEND_PING_NOT_ACT);

$title = _SEND_PING;
include("include/popup_head.php");

settype($_POST['mode'],"string");
if (!empty($_POST['trackback_url'])) {
   $trackback_url = KWL_UrlCheck($_POST['trackback_url']);
}
if ($_POST['mode'] == "sendping" && $trackback_url) {
   $id = !empty($user['name']) ? $user['name'] : "Anonymous";
   
   $title = stripslashes($_POST['title']);
   $blog_name = $CONF['SiteName'] ." : ". $id;
   $excerpt = stripslashes($_POST['excerpt']);

   if (!empty($_POST['chg_encode'])) {
      $title = iconv($_POST['old_encode'],$_POST['new_encode'],$title);
      $blog_name = iconv($_POST['old_encode'],$_POST['new_encode'],$blog_name);
      $excerpt = iconv($_POST['old_encode'],$_POST['new_encode'],$excerpt);      
   }

   $title = urlencode($title);
   $blog_name = urlencode($blog_name);
   $excerpt = urlencode($excerpt);
   $url = urlencode(KWL_MakeStoryLink($_POST['story']));
   $query = "title=$title&url=$url&blog_name=$blog_name&excerpt=$excerpt";
   $result= '';

   if (strstr($trackback_url, '?')) {
      $trackback_url.= "&".$query;
      $sock = @fopen($trackback_url, 'r');
      $result = @fread($sock, 4096);
      
   } else {

      $target = parse_url($trackback_url);
      if ($target["query"] != "") $target["query"] = "?" . $target["query"];

      /* now we send ping */   
      $sock = @fsockopen($target['host'], 80);
      if (!is_resource($sock)) die("trackback_send: Couldn't connect to {$target['host']}.");
      @fputs($sock, "POST ".$target["path"].$target["query"]." HTTP/1.1\n");
      @fputs($sock, "Host: ".$target["host"]."\n");
      @fputs($sock, "Content-type: application/x-www-form-urlencoded\n");
      @fputs($sock, "Content-length: ". strlen($query)."\n");
      @fputs($sock, "Connection: close\n\n");
      @fputs($sock, $query);

      while(!feof($sock)) {
         $result .= fgets($sock, 128);
      }     
   }
   @fclose($sock);

   $VAR['Content'] = _SEND_PING_RESULT ."<br />Result : <i>$result</i><br /><br />\n".
                     "[ <a href=\"{$CONF['G_URL']}/sendping.php?story={$_POST['story']}\">". _SEND_PING_RESULT1 ."</a> | ".
                     "<a href=\"#\" onclick=\"window.close()\">". _CLOSE_WINDOW ."</a> ]";
   
} else {

   if (!empty($C_STORY)) $A =& $C_STORY;
   else $A = KWL_GetStory($story);

   if (!$A) {
      $VAR["Heading"] = _NOSTORY;
      $VAR["Content"] = "<br />" . _NOSTORY . "<br /><br />";
      KWL_DrawMain($VAR);
   } else {

      $out = new KWL_Html;

      $VAR["Content"] = $out->form_start("sendping.php","sendping") .
                        $out->table_start("100%",'',0,1,3) ."
      <tr>
         <td>* ". _TRACKBACK_URL ." : ".
         $out->input_form("text","trackback_url",'',40,256) ."</td>
      </tr>
      <tr>
         <td>" . _TITLE . " : ".
         $out->input_form("text","title",$A['Heading'],40,96) ."</td>
      </tr>
      <tr>
         <td>". _STORY .": ". KWL_FormResizer("sendping.excerpt",$size['text'],10) ."
         <br />". $out->textarea("excerpt",10,$size['text'],KWL_PrepareHtml($A['Content'])) ."</td>
      </tr>
      <tr>
         <td>\n";

      if (function_exists("iconv")) {
         if ($rdf_lang == "utf-8") $new_encode = "euc-kr";
         else $new_encode = "utf-8";
         $VAR['Content'] .= $out->input_form("hidden","new_encode",$new_encode).
                            $out->input_form("hidden","old_encode",$rdf_lang).
                            sprintf(_CHG_ENCODE,$new_encode) .
                            " : ". $out->check_box("chg_encode") . "<br />\n";
      }

      $VAR['Content'] .= $out->input_form("hidden","mode","sendping").
                         $out->input_form("hidden","story",$story).
                         $out->input_form("submit",'',_SEND_PING).
                         "<input type=\"button\" value=\"". _CANCEL ."\" onclick=\"window.close()\">".
                         "</td></tr>". $out->table_end() . $out->form_end();

   }

}

$VAR['Heading'] = _SEND_PING;
KWL_DrawMain($VAR);
?>
</body>
</html>
